
#include <stdafx.h>


#include <stdio.h>
#include <stdarg.h>


#include "wos.h"
#include "etc.h"
#include "deb.h"






static os_error errblock;


os_error * generror(int errno,char * format, ...)
{
 va_list    args;
 os_error * err;

 errblock.errnum=errno;

 va_start(args,format);
 vsprintf(errblock.errmess,format,args);
 va_end(args);

 err=&errblock;

 return(err);
 USE(errno);
}






os_error * XFormatError2(int code,char * name,char * format,...)
{
 va_list   args;
 char      v[512];

 FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
 NULL,
 code,
 0,
 errblock.errmess,
 sizeof(errblock.errmess),
 NULL);

 errblock.errnum=code;

 if(format)
 {
  va_start(args, format);
  vsprintf(v, format, args);

  sprintf(errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

  va_end(args);
 }
 else
 {
  sprintf(errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
 }

 return(&errblock);
}



os_error * XGetLastError2(char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       code;

 code=GetLastError();
 if(code==ERROR_SUCCESS)
 {
  return(NULL);
 }
 else
 {
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,code,0,errblock.errmess,sizeof(errblock.errmess),NULL);

  errblock.errnum=code;

  if(format)
  {
   va_start(args, format);
   vsprintf(v, format, args);

   sprintf(errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

   va_end(args);
  }
  else
  {
   sprintf(errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
  }

  return(&errblock);
 }
}






os_error * XGetFileAttributes(
  LPCTSTR lpFileName,   // pointer to the name of a file or directory
  DWORD * result
)
{
 DWORD code;

 code=GetFileAttributes(lpFileName);
 if(code==0xFFFFFFFF) return(XGetLastError2("GetFileAttributes","%s",lpFileName));
 *result=code;
 return(NULL);
}




os_error * XCreateDirectory(
  LPCTSTR lpPathName,                         // pointer to directory path string
  LPSECURITY_ATTRIBUTES lpSecurityAttributes  // pointer to security descriptor
)
{
 int code;

 code=CreateDirectory(lpPathName,lpSecurityAttributes);
 if(code==0) return(XGetLastError2("Create Directory","%s",lpPathName));
 return(NULL);
}




os_error * XCreateFile(
  LPCTSTR lpFileName,          // pointer to name of the file
  DWORD dwDesiredAccess,       // access (read-write) mode
  DWORD dwShareMode,           // share mode
  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                               // pointer to security attributes
  DWORD dwCreationDisposition,  // how to create
  DWORD dwFlagsAndAttributes,  // file attributes
  HANDLE hTemplateFile,         // handle to file with attributes to 
                               // copy
  HANDLE * filehandle
)
 
{

 *filehandle=CreateFile(lpFileName,dwDesiredAccess,dwShareMode,
                        lpSecurityAttributes,dwCreationDisposition,
                        dwFlagsAndAttributes,hTemplateFile);
 
 if(*filehandle==INVALID_HANDLE_VALUE) return(XGetLastError2("CreateFile","%s",lpFileName));
 return(NULL);
}



os_error * XFindNextFile(
  HANDLE hFindFile,  // handle to search
  LPWIN32_FIND_DATA lpFindFileData, 
                     // pointer to structure for data on found file
  int * eof
)
{
 os_error * err;
 int        code;

 code=FindNextFile(hFindFile,lpFindFileData);
 if(code==0)
 {
  err=XGetLastError2("FindNextFile","");
  if(err->errnum==ERROR_NO_MORE_FILES)
  {
   *eof=1;
   err=NULL;
  }
  return(err);
 }

 *eof=0;
 return(NULL);
}


os_error * XFindFirstFile(
  LPCTSTR lpFileName,  // pointer to name of file to search for
  LPWIN32_FIND_DATA lpFindFileData,
                       // pointer to returned information
  HANDLE * handle
)
{

 *handle=FindFirstFile(lpFileName,lpFindFileData);

 if(*handle==INVALID_HANDLE_VALUE) return(XGetLastError2("FindFirstFile","%s",lpFileName));
 return(NULL);
}


os_error * XFindClose(
  HANDLE hFindFile   // file search handle
)
{
 int code;

 code=FindClose(hFindFile);
 if(code==0) return(XGetLastError2("FindClose",NULL));
 return(NULL);
}




os_error * XWriteFile(
  HANDLE hFile,                    // handle to file to write to
  LPCVOID lpBuffer,                // pointer to data to write to file
  DWORD nNumberOfBytesToWrite,     // number of bytes to write
  LPDWORD lpNumberOfBytesWritten,  // pointer to number of bytes written
  LPOVERLAPPED lpOverlapped        // pointer to structure for overlapped I/O
)
{
 int code;

 code=WriteFile(hFile,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,lpOverlapped);
 if(code==0) return(XGetLastError2("WriteFile",NULL));
 return(NULL);
}





os_error * XCloseHandle(
  HANDLE hObject   // handle to object to close
)
{
 int code;

 code=CloseHandle(hObject);

 if(code==0) return(XGetLastError2("CloseHandle",NULL));
 return(NULL);
}








os_error * XReadFile(
  HANDLE hFile,                // handle of file to read
  LPVOID lpBuffer,             // pointer to buffer that receives data
  DWORD nNumberOfBytesToRead,  // number of bytes to read
  LPDWORD lpNumberOfBytesRead, // pointer to number of bytes read
  LPOVERLAPPED lpOverlapped    // pointer to structure for data
)
{
 int code;

 code=ReadFile(hFile,lpBuffer,nNumberOfBytesToRead,lpNumberOfBytesRead,lpOverlapped);

 if(code==0) return(XGetLastError2("ReadFile",NULL));
 return(NULL);
}





os_error * XRegOpenKeyEx(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey,  // address of name of subkey to open
  DWORD ulOptions,   // reserved
  REGSAM samDesired, // security access mask
  PHKEY phkResult    // address of handle to open key
)

{
 LONG code;

 code=RegOpenKeyEx(hKey,lpSubKey,ulOptions,samDesired,phkResult);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegOpenKey","%s",lpSubKey));
}





os_error * XRegQueryValueEx(
  HKEY hKey,           // handle to key to query
  LPTSTR lpValueName,  // address of name of value to query
  LPDWORD lpReserved,  // reserved
  LPDWORD lpType,      // address of buffer for value type
  LPBYTE lpData,       // address of data buffer
  LPDWORD lpcbData     // address of data buffer size
)
{
 LONG code;

 code=RegQueryValueEx(hKey,lpValueName,lpReserved,lpType,lpData,lpcbData);
 
 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegQueryValueEx","%s",lpValueName));
}



os_error * XRegCloseKey(
  HKEY hKey   // handle to key to close
)
{
 LONG code;

 code=RegCloseKey(hKey);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegCloseKey",NULL));
}
