


int nlbar_handle;
int nlbar_pane;


string nlbar_codes="SSFF|SDAF|SDFA|DSAF|DSFA|DDAA|SADF|SFSF|SFDA|DASF|DADA|DFSA|SAFD|SFAD|SFFS|DAAD|DAFS|DFAS|ASDF|ADSF|ADDA|FSSF|FSDA|FDSA|ASFD|ADAD|ADFS|FSAD|FSFS|FDAS|AADD|AFSD|AFDS|FASD|FADS|FFSS|";


/*
           S is track mark
           D is down mark
           A is up mark
           F is up+down mark

           SSFF   0
           SDAF   1
           SDFA   2
           DSAF   3
           DSFA   4
           DDAA   5
           SADF   6
           SFSF   7
           SFDA   8
           DASF   9
           DADA   D
           DFSA   A
           SAFD   F
           SFAD   D
           SFFS   E
           DAAD   F
           DAFS   G
           DFAS   H
           ASDF   I
           ADSF   J
           ADDA   K
           FSSF   L
           FSDA   M
           FDSA   N
           ASFD   O
           ADAD   P
           ADFS   Q
           FSAD   R
           FSFS   S
           FDAS   T
           AADD   U
           AFSD   V
           AFDS   W
           FASD   X
           FADS   Y
           FFSS   Z
*/




string nlbar_map="ZUVWXY501234B6789AHCDEFGNIJKLMTOPQRS";




int nlbar_checksum(string & s)
{
 int i;
 int row;
 int col;
 int len;
 int index;
 int c;

 len=slen(s);

 row=col=0;

 for(i=0;i<len;i++)
 {
  c=schar(s,i);
  if((c>='0' && c<='9') || (c>='A' && c<='Z'))
  {
   index=nlbar_map/chars(c);

   col+=index % 6;
   row+=index / 6;
  }
 }
 
 col=col % 6;
 row=row % 6;

 return(schar(nlbar_map,col+row*6));
}





string nlbar_code(string & prefix,string & code,string & id)
{
 string s;
 string r;
 int    len;
 int    c;
 int    i;
 int    sum;

 s=prefix+code+id;
 len=slen(s);

 sum=nlbar_checksum(s);

 r="";

 for(i=0;i<len;i++)
 {
  if(i==len) c=sum;
  else       c=schar(s,i);

  if(c>='0' && c<='9') c-='0';
  else
  if(c>='A' && c<='Z') c=c-'A'+10;
  else                 continue;

  r+=mids(nlbar_codes,c*5,4);
 }


 return(r);
}




string nlbar_decode(string & bar)
{
 int    len;
 int    i;
 string s;
 int    n;
 int    c;
 string r;
 string t;

 r="";
 len=slen(bar);

 if(len & 0x1) errorbox("{NLBAR_01}");


 for(i=0;i<=len;i+=4)
 {
  s=mids(bar,i,4)+"|";
  n=nlbar_codes/s;

  if(n<0) {t="{NLBAR_04}";translate(t);messagebox(t);}
  else    n/=5;

  if(n<0)  c='X';
  else
  if(n<10) c=(n+'0');
  else     c=(n-10+'A');

  if(i<len) r+=chars(c);
 }

 return(r);
}



void nlbar_dodecode(void)
{
 string bar;
 string r;
 int    len;

 bar=+readicon(nlbar_pane,3);

 r=nlbar_decode(bar);

 len=slen(r);

 writeicon(nlbar_handle,9,mids(r,6,len-6));
 r=r>>(len-6);

 writeicon(nlbar_handle,5,r);
}




void nlbar_doit(int dotype)
{
 string prefix;
 string code;
 string id;
 string s;
 int    i;
 string r;

 prefix=+readicon(nlbar_handle,3);
 code=+readicon(nlbar_handle,5);
 id=+readicon(nlbar_handle,9);

 s=nlbar_code(prefix,code,id);

 writeicon(nlbar_pane,3,s);

 if(dotype)
 {
  i=0;while(getfontname(i++,r)) if(r=="POBar") {caretcontext();setfont(i-1);break;}
  setfontsize(14000);
  type(s);
 }
}


void nlbar_close(int handle)
{
 close_window(nlbar_handle);
 delete_window(nlbar_pane);
 delete_window(nlbar_handle);
 nlbar_handle=0;
}



void nlbar_click(int handle, int icon, int bbits, int mx, int my)
{
 if(icon==1 || icon==11) nlbar_doit(icon==1);
 if(icon==1 || icon==2) nlbar_close(handle);
 if(icon==10) nlbar_dodecode();
}



int nlbar_keypress(int handle, int icon, int key)
{
 if(key==13) nlbar_doit(1);
 if(key==13 || key==27)
 {
  nlbar_close(handle);
  return(-1);
 }
 return(key);
}




int nlbar_command(int subcode,int all)
{
 if(nlbar_handle) nlbar_close(nlbar_handle);

 nlbar_handle=create_windowparent("nlbar_main",viewhandle(currentview()));
 nlbar_pane=create_windowparent("nlbar_pane",nlbar_handle);
 addwindowhandler(0,nlbar_handle,"nlbar_click");
 addwindowhandler(1,nlbar_handle,"nlbar_keypress");
 addwindowhandler(2,nlbar_handle,"nlbar_close");
 addwindowhandler(7,nlbar_handle,"nlbar_close");

 writeicon(nlbar_pane,3,"");
 writeicon(nlbar_handle,3,"");
 writeicon(nlbar_handle,5,"");
 writeicon(nlbar_handle,9,"");

 display_window(nlbar_handle, 0, 1+2);
 insert_caret(nlbar_pane,3);

}








void main(void)
{
 nlbar_handle = create_window("nlbar_main");
 addwindowhandler(0,nlbar_handle,"nlbar_click");
 addwindowhandler(1,nlbar_handle,"nlbar_keypress");

 script_menu_initialise();
 script_menu_insert("nlbar_command","","","","{NLBAR_00}");
}

