//->pagepal

int pagepal_handle;
int pagepal_toolbox=0;
int pagepal_centre=1;
int pagepal_view;
int pagepal_x0;
int pagepal_y1;




// update icon if it has changed

void pagepal_updateicon(int f, int i, int v)
{
 if(itos(v) != readicon(pagepal_handle, i))
  writeicon(pagepal_handle, i, itos(v));
}

void pagepal_shadeicon(int icon, int state)
{
 set_icon_state(pagepal_handle, icon, (1 << 22) * state, (1 << 22));
}


// update icons in page palette

void pagepal_updatepal(int view)
{
 int f;
 int oldview=pagepal_view;


 if(pagepal_handle)
 {
  if((oldview==0)!=(view==0))
  {
   pagepal_shadeicon(1,view==0);
   pagepal_shadeicon(5,view==0);
   pagepal_shadeicon(9,view==0);
  }

  if(view)
  {
   f = filefromview(view);
   pagepal_updateicon(f,11, chapterstart(f) + currentchapter(view));
   pagepal_updateicon(f, 5, pagestart(currentchapter(view), f) + currentpage(view));
   pagepal_updateicon(f, 9, documentchapters(f));
  }
 }
}


// display page palette, centred first time

void pagepal_display(void)
{
 display_window(pagepal_handle, 0, pagepal_centre);
 pagepal_centre = 0;
} 


void pagepal_open3(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 if(!pagepal_centre)
 {
  x1+=(pagepal_x0-x0);
  y0+=(pagepal_y1-y1);
  x0=pagepal_x0;
  y1=pagepal_y1;
 }
 else
 {
  pagepal_x0=x0;
  pagepal_y1=y1;
 }
 open_window(h,x0,y0,x1,y1,scx,scy,bh);
}


void pagepal_open5(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 pagepal_x0=x0;
 pagepal_y1=y1;
}





void pagepal_opentoolbox(int view)
{
 if(view)
 {
  pagepal_handle=create_windowparent("pagepal_m",viewhandle(view));

  addwindowhandler(0,pagepal_handle,"pagepal_click");
  addwindowhandler(1,pagepal_handle,"pagepal_keypress");
  addwindowhandler(2,pagepal_handle,"pagepal_closetoolbox");
  addwindowhandler(3,pagepal_handle,"pagepal_open3");
  addwindowhandler(5,pagepal_handle,"pagepal_open5");
  setwindowflags(pagepal_handle,8,8);
  pagepal_view=view;
  pagepal_updatepal(view);
  pagepal_display();
 }
}


// handler for pagepal window close icon

void pagepal_closetoolboxs(int handle)
{
 close_window(handle);
 delete_window(handle);
 pagepal_view=0;
 pagepal_handle=0;
}


void pagepal_closetoolbox(int handle)
{
 pagepal_closetoolboxs(handle);
 pagepal_toolbox=0;
}



// deal with 'pagepal' menu entry

int pagepal_entry(int entry,int subcode)
{
 pagepal_toolbox=!pagepal_toolbox;
 if(pagepal_toolbox) pagepal_opentoolbox(activeview());
 else				 pagepal_closetoolbox(pagepal_handle);

 return(0);
}


// Tick or un-tick 'pagepal' menu entry

int pagepal_flags(int entry, string &text)
{
 return(pagepal_toolbox);
}


// handler for click in palette

void pagepal_click(int handle, int icon, int bbits, int mx, int my)
{
 int f, c, p, c1, p1, c2, p2,ci,pi;


 if(pagepal_view)
 {
  if((icon == 12 || icon == 3 || icon == 6 || icon == 7) && (bbits == 1 || bbits == 4))
  {
   f=filefromview(pagepal_view);
   c1=c=currentchapter(pagepal_view);
   p1=p=currentpage(pagepal_view);

   while(1)
   {
    pi=p;
    ci=c;

    if(icon == 12 && bbits == 4 || icon == 3 && bbits == 1)
    {
     if(c) --c;
    }

    if(icon == 12 && bbits == 1 || icon == 3 && bbits == 4)
    { 
     if(c<documentchapters(f)) ++c;
    }

    if(icon == 6 && bbits == 4 || icon == 7 && bbits == 1) 
    {
     if(p) --p;
     else
     if(c) 
     {
      --c;
      p = chapterpages(c, f) - 1;
     }
    }

    if(icon == 6 && bbits == 1 || icon == 7 && bbits == 4)
    {
     if(p < chapterpages(c, f) - 1)
      ++p;
     else
     if(c < documentchapters(f) - 1)
     {
      p = 0;
      ++c;
     }
    }

    if((p==pi) && (c==ci)) break;

    gotopage(p,c,pagepal_view);

    p2=currentpage(pagepal_view);
    c2=currentchapter(pagepal_view);

    if((p2!=p1) || (c2!=c1)) break;

   }
   pagepal_updatepal(pagepal_view);
  }
 }
}


// handler for Return key in writeable

int pagepal_keypress(int handle, int icon, int key)
{
 int f, c, p;

 if(key==13)
 {		 
  f = filefromview(pagepal_view);

  c = stoi(readicon(handle, 11)) - chapterstart(f);
  p = stoi(readicon(handle, 5)) - pagestart(c, f);
  gotopage(p, c, pagepal_view);
  pagepal_updatepal(pagepal_view);
  return(-1);
 }

 return(key);
}



// update page palette when current page changes

void pagepal_pagechange(int user, int view)
{
 pagepal_updatepal(view);
}



void pagepal_activeview(int user,int view,int gain)
{

 if(gain && pagepal_toolbox && view!=pagepal_view)
 {
  pagepal_opentoolbox(view);
 }

 if(!gain && pagepal_toolbox && view && view==pagepal_view)
 {
  pagepal_closetoolboxs(pagepal_handle);
 }
}




// add 'pagepal' option to 'Applets' menu
// create window and add window handlers

void main(void)
{
 script_menu_initialise();

 script_menu_insert("pagepal_entry","pagepal_flags","","","{PAGEPAL_00}");

 addeventhandler(0x216, 0, "pagepal_pagechange");
 addeventhandler(0x215, 0, "pagepal_activeview");
}
