/*->c.colcode */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"



#include "view.h"
#include "file.h"

#include "dbscale.h"

#include "xcolour.h"
#include "xxcolour.h"

#include "colsep.h"
#include "colseplink.h"




#include "csstr.h"

#include "colcode.h"





static int csplate(colourstr * cs,int spot)
{
 return(
           ((cs->flags & COLOURPLATE) && spot)
        || 
           ((cs->n==KEYBLACK  || cs->n==KEYYELLOW || 
             cs->n==KEYCYAN   || cs->n==KEYMAGENTA) && !spot)
       );
}



static int deffreq;



static void csdef(colplatestr * platep,colourstr * cs,int spot)
{
 memset(platep,0,sizeof(colplatestr));

 platep->spot=spot;
 platep->colour=cs->n;
 platep->frequency=deffreq;
 platep->print=spot?0:1;
 platep->psscreen=0;

 if(spot)                platep->angle=45*0x10000;
 else
 if(cs->n==KEYCYAN)      platep->angle=105*0x10000;
 else
 if(cs->n==KEYMAGENTA)   platep->angle=75*0x10000;
 else
 if(cs->n==KEYYELLOW)    platep->angle=90*0x10000;
 else
 /* if(cs->n==KEYBLACK) */ platep->angle=45*0x10000;

}




os_error * colputsep(filestr * file,colsephdrstr * hdr,colplatestr ** platep)
{
 os_error        * err;
 colsepobjectstr * csp;
 int               newsize;

 newsize=sizeof(colsepobjectstr)+(hdr->plates-1)*sizeof(colplatestr);

 if(file->hdr.colsep)
     err=fob_change(file->hdr.colsep,file,newsize,(fobjptr)&csp);
 else
     err=fob_create(newsize,file,OCOLSEPS,(fobjptr)&csp);

 if(!err)
 {
  csp->data.hdr=*hdr;
  XMEMCPYX(csp->data.plate,*platep,sizeof(colplatestr)*hdr->plates);
  file->hdr.colsep=csp->key;
 }

 return(err);
}






os_error * cscheckplates(filestr * file,int * sizep,colplatestr ** platep)
{
 os_error        * err;
 colourstr       * cs;
 int               r;
 int               w;
 colourbasestr   * colourbase;
 int               colours;
 int               i;
 int               j;
 int               size;
 int               key;
 int               spot;



 err=NULL;

 size=*sizep;


 for(w=r=0;r<size;r++)
 {
  key=(*platep)[r].colour;
  findcoloursp(key,&cs,file);
  if(cs->n==key && csplate(cs,(*platep)[r].spot))
  {
   if(r!=w) (*platep)[w]=(*platep)[r];
   w++;
  }
 }


 if(w) deffreq=(*platep)[0].frequency;
 else  deffreq=150;


 colours=file->hdr.colours;
 colourbase=(colourbasestr*)fob_find(colours,file);

 for(i=0;i<colourbase->n;i++)
 {
  for(spot=0;spot<2;spot++)
  {
   if(csplate(&colourbase->colour[i],spot))
   {
    for(j=0;j<w;j++)
    {
     if((*platep)[j].colour==colourbase->colour[i].n &&
        (*platep)[j].spot==(unsigned int)spot) break;
    }

    if(j>=w)
    {
     if(w>=size)
     {
      err=flex_extend((flex_ptr)platep,sizeof(colplatestr)*(size+1));
      if(err) break;
      size++;
     }

     colourbase=(colourbasestr*)fob_find(colours,file);

     csdef(&(*platep)[w],&colourbase->colour[i],spot);
     w++;
    }
   }
  }
 }

 *sizep=w;

 return(err);
}




os_error * colgetsep(filestr * file,colsephdrstr * hdr,colplatestr ** platep)
{
 os_error        * err;
 int               size;
 colsepobjectstr * csp;


 err=NULL;

 if(file->hdr.colsep)
 {
  csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);
  *hdr=csp->data.hdr;
  size=hdr->plates;

  if(platep)
  {
   err=flex_alloc((flex_ptr)platep,sizeof(colplatestr)*size);
   if(!err)
   {
    csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);
    XMEMCPYX(*platep,csp->data.plate,sizeof(colplatestr)*size);
   }
  }
 }
 else
 {
  memset(hdr,0,sizeof(colsephdrstr));
  hdr->doseptext=1;
  xzstrncpy(hdr->septext,"{filename} P{pagenumber} {datetime}",sizeof(hdr->septext));
  if(platep)
  {
   err=flex_alloc((flex_ptr)platep,0);
  }
 }

 if(!err && platep)
 {
  err=cscheckplates(file,&hdr->plates,platep);
 }

 return(err);
}




os_error * colsepinit(filestr * file)
{
 os_error     * err;
 colsephdrstr   hdr;
 colplatestr  * platep;

 err=colgetsep(file,&hdr,&platep);
 if(!err)
 {
  colputsep(file,&hdr,&platep);
  flex_free((flex_ptr)&platep);
 }

 return(err);
}






/* NB s==source d==dest. */

os_error * csmkstyle(int eventn,int user,filestr * dfile,filestr * sfile)
{
 os_error        * err;
 colsepobjectstr * csp;
 int               cs;

 err=NULL;

 if(sfile && sfile->hdr.colsep)
 {
  err=fob_copy((fobjptr)&csp,dfile,sfile->hdr.colsep,sfile);
  if(!err)
  {
   cs=csp->key;
   dfile->hdr.colsep=cs;
  }
 }
 else
 {
  err=colsepinit(dfile);
 }

 return(err);

 USE(eventn);
 USE(user);
}



os_error * csnewevent(int eventn,int user,filestr * file,void * data)
{
 return(csmkstyle(eventn,user,file,getdeffile()));
 USE(data);
}



os_error * csbareevent(int eventn,int user,filestr * file,void * data)
{
 return(csmkstyle(eventn,user,file,getdeffile()));
 USE(data);
}




