/*->c.dbprocess */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"


#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "xmath.h"
#include "redraw.h"
#include "colour.h"
#include "drag.h"
#include "fsx.h"
#include "bf.h"
#include "drawmod.h"
#include "deb.h"

#include "dbhi.h"
#include "mhi.h"



#include "str.h"
#include "constants.h"

#include "reslink.h"
#include "units.h"
#include "posn.h"
#include "object.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "select.h"

#include "xxcolour.h"
#include "xcolour.h"
#include "dbcolour.h"
#include "dbscale.h"



#include "pxstr.h"
#include "pict.h"
#include "pixtool.h"


#include "csstr.h"

#include "colsep.h"

#include "dbprocess.h"
#include "dbcolsep.h"
#include "csprocess.h"




static dboxstr       processbox;

static viewstr     * cview;
static filestr     * cfile;
static int           cpictbox;
static int           cprocess;
static int           csection;
static int           cpage;



static dbprocessstr  dbpr;
static dbprocessstr  cdbpr;

static int           ctagfound;


static int           pbrightness;
static int           pcontrast;
static int           pgamma;
static int           skipupdate;



#define GRIDICON 10
#define ACTIVEICON 4




#define DXBLOB 6
#define DYBLOB 6

#define BX     10
#define BY     10







static void calctansub(int * result,int * prev,int * curr,
                                                 int * next,int forward)
{
 double prevangle;
 double nextangle;
 double diff;
 double normal;
 double tangent;
 int    prevdist;
 int    nextdist;


 if(prev) 
 {
  prevdist=pythag(curr[0]-prev[0],curr[1]-prev[1])/3;
  if(prevdist)
         prevangle=atan2((double)prev[1]-(double)curr[1],
                         (double)prev[0]-(double)curr[0]);
  else   prevangle=0.0;
 }
 else
 {
  prevangle=0.0;
  prevdist=0;
 }

 if(next)
 {
  nextdist=pythag(curr[0]-next[0],curr[1]-next[1])/3;
  if(nextdist)
         nextangle=atan2((double)next[1]-(double)curr[1],
                         (double)next[0]-(double)curr[0]);
  else   nextangle=0.0;
 }
 else
 {
  nextangle=0.0;
  nextdist=0;
 }


 if(!prev) prevangle=nextangle+PI;
 if(!next) nextangle=prevangle-PI;


 diff=prevangle-nextangle;
 normal=prevangle-diff/2;

 if(diff<0) normal=normal+PI;


 if(forward)
 {
  tangent=normal+PI/2;
  result[0]=curr[0]+(int)(prevdist*cos(tangent));
  result[1]=curr[1]+(int)(prevdist*sin(tangent));
 }
 else
 {
  tangent=normal-PI/2;
  result[0]=curr[0]+(int)(nextdist*cos(tangent));
  result[1]=curr[1]+(int)(nextdist*sin(tangent));
 }


 result[0]=CUT(result[0],0,CMAX);
 result[1]=CUT(result[1],0,CMAX);
}


static void calctangents(int * path,int skip,int doloop)
{
 int * curr;
 int * prev;
 int * prevp;
 int * next;
 int * first;
 int   looped;
 int   loop;

 prevp=NULL;
 prev=NULL;
 curr=NULL;

 first=path;
 looped=0;
 loop=doloop;



 while((*path && !looped) || ((looped || !*path) && doloop && loop--))
 {
  if(*path==DRAWEND || *path==DRAWCLOSE)
  {
   looped=1;
   path=first+3;
  }

  if(*path==DRAWMOVE || *path==DRAWDRAW)
  {
   curr=path+1;
   path+=3;
   skip--;
  }
  else
  if(*path==DRAWCURVE)   /* need last point and next */
  {
   if(path[7]==DRAWEND || path[7]==DRAWCLOSE)
   {
    if(doloop)
    {
          /* assume it starts with a move */

     if(first[3]==DRAWMOVE || first[3]==DRAWDRAW)
     {
      next=first+(3+1);
     }
     else
     if(first[3]==DRAWCURVE) next=first+(3+5);
     else                    next=NULL;
    }
    else next=NULL;
   }
   else
   if(path[7]==DRAWMOVE || path[7]==DRAWDRAW)
   {
    next=path+(7+1);
   }
   else
   if(path[7]==DRAWCURVE)
   {
    next=path+(7+5);
   }
   else
   {
    next=NULL;
   }

   curr=path+5;

   if(skip--<=0)
   {
    calctansub(path+1,prevp,prev,curr,0);
    calctansub(path+3,prev,curr,next,1);
   }

   path+=7;
  }


  prevp=prev;
  prev=curr;
 }
}






void makegammapath(int * path,int n,xpgpointstr * p,int line)
{
 int i;
 int j;


 path[0]=DRAWMOVE;
 path[1]=p->x;
 path[2]=p->y;
 p++;

 j=3;

 if(line)
 {
  for(i=1;i<n;i++)
  {
   path[j]=DRAWDRAW;
   path[j+1]=p->x;
   path[j+2]=p->y;
   p++;
   j+=3;
  }

  path[j]=DRAWEND;
 }
 else
 {
  for(i=1;i<n;i++)
  {
   path[j]=DRAWCURVE;
   path[j+5]=p->x;
   path[j+6]=p->y;
   p++;
   j+=7;
  }

  path[j]=DRAWEND;

  calctangents(path,0,0);
 }
}





static void gammacurve(int ox,int oy,int w,int h,int n,xpgpointstr * p)
{
 os_error * err;
 int        path[MAXGAMMAPOINT*7];
 int        tr[6];


 makegammapath(path,n,p,dbpr.tool==XPSTR);

 tr[0]=w*((256*0x10000)/CMAX);
 tr[1]=0;
 tr[2]=0;
 tr[3]=h*((256*0x10000)/CMAX);
 tr[4]=ox*256;
 tr[5]=oy*256;

 err=Draw_Stroke(path,0,DRAWMOD_OSUNITS|0x80000000,NULL,(transformstr*)tr,0,0);
}





static void gammablobs(int ox,int oy,int w,int h,int n,xpgpointstr * p)
{
 int i;
 int x;
 int y;

 for(i=0;i<n;i++)
 {
  x=ox+(p->x*w)/CMAX;
  y=oy+(p->y*h)/CMAX;
  p++;

  bbc_move(x-DXBLOB,y-DYBLOB);
  bbc_plot(96+5,x+DXBLOB,y+DYBLOB);
 }
}







static void makelincurve(void)
{
 double gamma;
 double grad;
 double contrast;
 double brightness;
 double y0;
 double y1;
 double x0;
 double x1;
 int    i;
 int    j;
 int    ix0;
 int    ix1;
 int    iy0;
 int    iy1;
 int    ixm[4];
 int    iym[4];
 double xm;
 double ym;
 int    k;


 if(dbpr.tool==XPLIN)
 {
  ix0=iy0=ix1=iy1=0; /* compiler */

  for(i=0;i<4;i++)
  {
   if((dbpr.mode & (1<<i)) && !(dbpr.mode==XPALL && i>0))
   {
    gamma=((double)dbpr.gamma[i])/((double)0x10000);
 
    grad=((double)dbpr.contrast[i])/((double)0x10000);
    grad=(PI/4.0)*(1.0+grad);

    if(grad>=(PI/2-0.01)) grad=(PI/2-0.01);
    contrast=tan(grad);

    brightness=((double)dbpr.brightness[i])/((double)0x10000);
    brightness=brightness+0.5*(1.0-contrast);

    y0=brightness;
    y1=y0+contrast;
   
                                                                                    if(contrast==0.0)
    {
     x0=0.0;
     x1=1.0;
    }
    else
    {
     x0=(-brightness)/contrast;
     if(x0<0) x0=0;
     else     x0=pow(x0,1.0/gamma);

     x1=(1.0-brightness)/contrast;
     if(x1<0) x1=0;
     else     x1=pow(x1,1.0/gamma);
    }


    if(x0<0)   x0=0.0;
    else
    if(x0>1.0) x0=1.0;

    if(x1<0)   x1=0.0;
    else
    if(x1>1.0) x1=1.0;

    if(y0<0)   y0=0.0;
    else
    if(y0>1.0) y0=1.0;
                                                                                    if(y1<0)   y1=0.0;
    else
    if(y1>1.0) y1=1.0;


    ix0=(int)((double)CMAX*x0);
    ix1=(int)((double)CMAX*x1);
    iy0=(int)((double)CMAX*y0);
    iy1=(int)((double)CMAX*y1);

    for(k=0;k<4;k++)
    {
     xm=x0+((x1-x0)*(double)(k+((gamma<1.0)?1:4)))/8.0;
     ym=brightness+contrast*pow(xm,gamma);

     if(xm<0.0) xm=0.0;
     else
     if(xm>1.0) xm=1.0;
    
     if(ym<0.0) ym=0.0;
     else
     if(ym>1.0) ym=1.0;

     ixm[k]=(int)((double)CMAX*xm);
     iym[k]=(int)((double)CMAX*ym);
    }
   }


   if(dbpr.mode & (1<<i))
   {
    dbpr.gamman[i]=6;
    dbpr.gammapoint[i][0].x=ix0;
    dbpr.gammapoint[i][0].y=iy0;

    for(k=0;k<4;k++)
    {
     dbpr.gammapoint[i][k+1].x=ixm[k];
     dbpr.gammapoint[i][k+1].y=iym[k];
    }

    dbpr.gammapoint[i][5].x=ix1;
    dbpr.gammapoint[i][5].y=iy1;

    if(dbpr.inverted)
    {
     for(j=0;j<dbpr.gamman[i];j++)
     {
      dbpr.gammapoint[i][j].y=CMAX-dbpr.gammapoint[i][j].y;
     }
    }
   }
  }
 }
}





static int cmpgamma(const void * p1,const void * p2)
{
 xpgpointstr * p1p=(xpgpointstr*)p1;
 xpgpointstr * p2p=(xpgpointstr*)p2;

 if(p1p->x==p2p->x) return(p1p->y-p2p->y);
 else               return(p1p->x-p2p->x);
}



static void gammasort(int n,xpgpointstr * p)
{
 qsort(p,n,sizeof(xpgpointstr),cmpgamma);
}












static int dragpt;
static int dragpx;
static int dragpy;











static int findpoint(int n,xpgpointstr * p,int px,int py,int w,int h)
{
 int i;
 int x;
 int y;

 for(i=0;i<n;i++)
 {
  x=p->x;
  y=p->y;
  p++;

  x=(x*w)/CMAX;
  y=(y*h)/CMAX;

  if((ABS(x-px))<=DXBLOB && (ABS(y-py))<=DYBLOB) return(i);
 }

 return(-1);
}




static char ccols[3][4]=
{
 WIMPRED,   WIMPGREEN, WIMPDBLUE,  WIMPWHITE,
 WIMPRED,   WIMPGREEN, WIMPDBLUE,  WIMPWHITE,
 WIMPLBLUE ,WIMPRED,   WIMPYELLOW, WIMPBLACK,

};






static os_error * redrawgrid(wimp_redrawstr * redrawstr,int handle)
{
 os_error * err;
 int        ox;
 int        oy;
 iconstr    icon;
 int        w;
 int        h;
 int        i;
 vdustr   * cvdu;


 cvdu=getcvdu();


 err=geti(handle,GRIDICON,&icon);

 if(iconinredraw(redrawstr,&icon))
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  h=icon.iy1-icon.iy0;
  w=icon.ix1-icon.ix0;

  err=wimp_setcolour(WIMPWHITE);
  bbc_rectanglefill(ox+icon.ix0+cvdu->deltax,
                 oy+icon.iy0+cvdu->deltay,w-3*cvdu->deltax,h-3*cvdu->deltay);

  h-=2*BY;
  w-=2*BX;
  icon.ix0+=BX;
  icon.iy0+=BY;


  if(dbpr.mode!=XPALL)
  {
   for(i=0;i<4;i++)
   {
    if(!(dbpr.mode & (1<<i)) && ccols[dbpr.model][i])
    {
     err=wimp_setcolour(ccols[dbpr.model][i]);
     gammacurve(ox+icon.ix0,oy+icon.iy0,w,h,dbpr.gamman[i],dbpr.gammapoint[i]);
    }
   }
  }

  for(i=0;i<4;i++)
  {
   if((dbpr.mode & (1<<i)) && ccols[dbpr.model][i])
   {
    err=wimp_setcolour(dbpr.mode==XPALL?WIMPBLACK:ccols[dbpr.model][i]);

    gammacurve(ox+icon.ix0,oy+icon.iy0,w,h,dbpr.gamman[i],dbpr.gammapoint[i]);

    if(dbpr.tool!=XPLIN)
     gammablobs(ox+icon.ix0,oy+icon.iy0,w,h,dbpr.gamman[i],dbpr.gammapoint[i]);

    break;
   }
  }

 }

 return(err);
}






static void gammaupdate(void)
{
 wimp_redrawstr redrawstr;
 int            more;
 iconstr        icon;

 geti(processbox.handle,GRIDICON,&icon);

 redrawstr.w=processbox.handle;
 redrawstr.box.x0=icon.ix0;
 redrawstr.box.x1=icon.ix1;
 redrawstr.box.y0=icon.iy0;
 redrawstr.box.y1=icon.iy1;

 wimp_update_wind(&redrawstr,&more);
 while(more)
 {
  redrawgrid(&redrawstr,processbox.handle);
  wimp_get_rectangle(&redrawstr,&more);
 }
}



static void gammarefresh(int all)
{
 if(all) wimp_set_icon_state(processbox.handle,GRIDICON,
                                       (wimp_iconflags)0,(wimp_iconflags)0);
 else    gammaupdate(); 

 USE(all);
}



static os_error * imageupdate(void)
{
 os_error * err;
/* int        time=clock(); */

 err=pxrefresh(cpictbox,csection,cpage,cfile);

/* dprintf(0,"time=%d",clock()-time); */

 return(err);
}



static os_error * processclose(int code)
{
 os_error        * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=applyprocess(&dbpr,(cprocess && ctagfound)?&cdbpr:NULL,
           (cprocess?PROCHADPROC:0)|PROCUNDO|PROCMOD,csection,cpictbox,cfile);
  if(!err)
  {
   if(code==DBAPPLY)
   {
    err=getprocess(&dbpr,cpictbox,&cprocess,&ctagfound,cfile);
    if(cprocess && ctagfound) cdbpr=dbpr;
   }
   if(!dbpr.update) imageupdate();
  }
 }
 else
 if(code==DBCANCEL)
 {
  err=applyprocess(&cdbpr,NULL,cprocess?(ctagfound?0:PROCSCRAPTAG):PROCSCRAP,
                                                      csection,cpictbox,cfile);
  imageupdate();
 }

 return(err);
}




static int wasactive;

static os_error * pactiveupdate(int force)
{
 os_error * err;
 int        nowactive;
 int        i;
 int        lt;

 err=NULL;



 nowactive=dbpr.duotone || dbpr.inverted;
 if(!nowactive)
 {
  lt=(dbpr.model==XPCMYK)?4:3;

  if(dbpr.tool==XPLIN)
  {
   for(i=0;i<lt;i++)
   {
    if(dbpr.mode & (1<<i))
    {
//     cprintf("pbr %x pcon %x pgam %x",pbrightness,pcontrast,pgamma);
     nowactive=(pbrightness!=0);
     if(nowactive) break;

     nowactive=(pcontrast!=0);
     if(nowactive) break;

     nowactive=(pgamma!=0);
     if(nowactive) break;
    }
    else
    {
//     cprintf("gamma %x bri %x con %x",dbpr.gamma[i],dbpr.brightness[i],dbpr.contrast[i]);
     nowactive=(dbpr.gamma[i]!=0x10000);
     if(nowactive) break;

     nowactive=(dbpr.brightness[i]!=0);
     if(nowactive) break;

     nowactive=(dbpr.contrast[i]!=0);
     if(nowactive) break;
    }
   }
  }
  else
  {
   for(i=0;i<lt;i++)
   {
    nowactive=(dbpr.gamman[i]!=2);
    if(nowactive) break;

    nowactive=(dbpr.gammapoint[i][0].y!=0)    || (dbpr.gammapoint[i][0].x!=0) ||
              (dbpr.gammapoint[i][1].y!=CMAX) || (dbpr.gammapoint[i][1].x!=CMAX);

    if(nowactive) break;    
   }
  }
 }

// cprintf("nowactive %d",nowactive);

 if(wasactive!=nowactive || force)
 {
  writeiconc(processbox.handle,ACTIVEICON,nowactive?"{UPPR1}":"{UPPR0}");
  wasactive=nowactive;
 }

 return(err);
}




static os_error * processupdate(void)
{
 os_error * err;

 err=NULL;

 if(dbpr.update)
 {
  err=applyprocess(&dbpr,cprocess?&cdbpr:NULL,0,csection,cpictbox,cfile);
  imageupdate();
 }

 pactiveupdate(0);

 return(err);
}




static os_error * griddragmove(int handle,int userhandle,wimp_mousestr * mstr)
{
 int           w;
 int           h;
 int           x;
 int           y;
 int           px;
 int           py;
 int           maxpt;
// wimp_mousestr mstr;
 windowstr     window;
 iconstr       icon;
 int           i;
 int           x0;
 int           x1;
 int           y0;
 int           y1;



// wimp_get_point_info(&mstr);
 if(mstr->x!=dragpx || mstr->y!=dragpy)
 {
  getw(processbox.handle,&window);
  geti(processbox.handle,GRIDICON,&icon);

  dragpx=mstr->x;
  dragpy=mstr->y;

  w=icon.ix1-icon.ix0-2*BX;
  h=icon.iy1-icon.iy0-2*BY;

  px=x=dragpx-(window.bx+icon.ix0+BX);
  py=y=dragpy-(window.by+icon.iy0+BY);

  x=(x*CMAX)/w;
  y=(y*CMAX)/h;

  if(x<0)    x=0;
  if(x>CMAX) x=CMAX;
  if(y<0)    y=0;
  if(y>CMAX) y=CMAX;


  for(i=0;i<4;i++)
  {
   if(dbpr.mode & (1<<i))
   {
    maxpt=dbpr.gamman[i]-1;

    if(dragpt==0 || dragpt==maxpt)
    {
     x0=x;
     x1=CMAX-x;
     y0=y;
     y1=CMAX-y;

     if(x0<y0 && x0<y1 && x0<x1) x=0;
     else
     if(x1<y0 && x1<y1 && x1<x0) x=CMAX;
     else
     if(y0<x0 && y0<x1 && y0<y1) y=0;
     else
     if(y1<x0 && y1<x1 && y1<y0) y=CMAX;
    }

    dbpr.gammapoint[i][dragpt].x=x;
    dbpr.gammapoint[i][dragpt].y=y;
   }
  }

  gammarefresh(0);
 }

 return(NULL);

 USE(handle);
}




static os_error * griddragend(int handle,int userhandle,wimp_box * box)
{
 os_error * err;

// err=remzeroevent(griddragzero,handle);

 err=processupdate();

 return(err);

 USE(userhandle);
 USE(box);
}





static void makepoint(int x,int y)
{
 int i;

 for(i=0;i<4;i++)
 {
  if(dbpr.mode & (1<<i))
  {
   if(dbpr.gamman[i]<MAXGAMMAPOINT)
   {
    dbpr.gammapoint[i][dbpr.gamman[i]].x=x;
    dbpr.gammapoint[i][dbpr.gamman[i]].y=y;
    dbpr.gamman[i]++;
    gammasort(dbpr.gamman[i],dbpr.gammapoint[i]);
   }
  }
 }

 gammarefresh(0);
 processupdate();
}





static void zappoint(int pt)
{
 int i;

 for(i=0;i<4;i++)
 {
  if(dbpr.mode & (1<<i))
  {
   if(pt>0 && pt<(dbpr.gamman[i]-1))
   {
    XMEMCPYX(&dbpr.gammapoint[i][pt],
           &dbpr.gammapoint[i][pt+1],(MAXGAMMAPOINT-pt)*sizeof(xpgpointstr));

    dbpr.gamman[i]--;
    gammasort(dbpr.gamman[i],dbpr.gammapoint[i]);
   }
  }
 }

 gammarefresh(0);
 processupdate();
}











static os_error * gridclick(int handle,wimp_mousestr * m)
{
 os_error * err;
 int        x;
 int        y;
 int        px;
 int        py;
 int        w;
 int        h;
 int        pt;
 windowstr  window;
 iconstr    icon;
 int        i;
 int        x0;
 int        y0;



 err=getw(handle,&window);
 geti(handle,GRIDICON,&icon);


 w=icon.ix1-icon.ix0-2*BX;
 h=icon.iy1-icon.iy0-2*BY;

 x0=(window.bx+icon.ix0+BX);
 y0=(window.by+icon.iy0+BY);

 px=x=m->x-x0;
 py=y=m->y-y0;

 x=(x*CMAX)/w;
 y=(y*CMAX)/h;

 if(x<0)    x=0;
 if(x>CMAX) x=CMAX;
 if(y<0)    y=0;
 if(y>CMAX) y=CMAX;


 if(dbpr.tool==XPSTR || dbpr.tool==XPCUR)
 {
  for(i=0;i<4;i++)
  {
   if(dbpr.mode & (1<<i))
   {
    pt=findpoint(dbpr.gamman[i],dbpr.gammapoint[i],px,py,w,h);

    if(pt>0  && m->bbits==0x1)  zappoint(pt);
    else
    if(pt<0  && m->bbits==0x4)  makepoint(x,y);
    else
    if(pt>=0 && m->bbits==0x40)
    {
     dragpt=pt;
     dragpx=m->x;
     dragpy=m->y;

     if(!err) err=userdrag(handle,x0,y0,x0+w,y0+h);
     if(!err) err=startdrag2(handle,0,griddragend,griddragmove);
//     if(!err) err=addzeroevent(griddragzero,handle);

    }
    break;
   }
  }
 }

 return(err);
}



















static os_error *processcolredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                                     int more)
{
 os_error * err;
 int        colour;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,44,vfindcolour2(NULL,cfile,&dbpr.start));
  redrawblock(redrawstr,handle,47,vfindcolour2(NULL,cfile,&dbpr.end));

  redrawgrid(redrawstr,handle);

  colour=(dbpr.tool==XPLIN)?WIMPBLACK:WIMPGREY2;

  redrawslider3(redrawstr,23,handle,colour,pbrightness,MAXBRI,MINBRI);
  redrawslider3(redrawstr,30,handle,colour,pcontrast,MAXCON,MINCON);
  redrawslider3(redrawstr,37,handle,colour,pgamma,MAXGAM,MINGAM);

  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * processredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=processcolredrawsub(handle,&redrawstr,more);

 return(err);
 USE(userhandle);
}



static void processpickcloses(colourvalue * colour)
{
 dbpr.start=*colour;
 wimp_set_icon_state(processbox.handle,44,(wimp_iconflags)0,(wimp_iconflags)0);
 if(dbpr.duotone) processupdate();
}



static void processpickclosee(colourvalue * colour)
{
 dbpr.end=*colour;
 wimp_set_icon_state(processbox.handle,47,(wimp_iconflags)0,(wimp_iconflags)0);
 if(dbpr.duotone) processupdate();
}





static os_error * processicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case       45:
                err=pickcolour(cfile,&dbpr.start,processpickcloses,
                                                            &processbox);
                break;

  case       48:
                err=pickcolour(cfile,&dbpr.end,processpickclosee,
                                                            &processbox);
                break;


  case GRIDICON:
                err=gridclick(handle,m);   
                break;
 }

 return(err);
 USE(userhandle);
 USE(handle);
}





static int gammalocal2absolute(int value)
{
 if(value<0) return(0x10000+scale(value,950,1000));
 else        return(0x10000+scale(value,475,100));
}


static int gammaabsolute2local(int value)
{
 if(value<0x10000) return(scale(value-0x10000,1000,950));
 else              return(scale(value-0x10000,100,475));
}



static void setpbrightness(void)
{
 int i;

 for(i=0;i<4;i++)
 {
  if(dbpr.mode & (1<<i))
  {
   pbrightness=dbpr.brightness[i];
   pcontrast=dbpr.contrast[i];
   pgamma=gammaabsolute2local(dbpr.gamma[i]);
   break;
  }
 }
}


static void putpbrightness(void)
{
 int i;

 if(dbpr.tool==XPLIN)
 {
  for(i=0;i<4;i++)
  {
   if(dbpr.mode & (1<<i))
   {
    dbpr.brightness[i]=pbrightness;
    dbpr.contrast[i]=pcontrast;
    dbpr.gamma[i]=gammalocal2absolute(pgamma);
   }
  }
 }
}





static oldmode;


static os_error * setmode(int handle,int userhandle,wimp_mousestr * m)
{
 int i;
 int j;


 if(dbpr.mode!=oldmode)
 {
  if(dbpr.mode==XPALL)
  {
   for(i=1;i<4;i++)
   {
    dbpr.gamman[i]=dbpr.gamman[0];
    dbpr.brightness[i]=dbpr.brightness[0];
    dbpr.contrast[i]=dbpr.contrast[0];
    dbpr.gamma[i]=dbpr.gamma[0];

    for(j=0;j<dbpr.gamman[0];j++)
    {
     dbpr.gammapoint[i][j]=dbpr.gammapoint[0][j];
    }
   }
  }

  setpbrightness();
  skipupdate=1;
  dbchangevalue(&pbrightness,&processbox);
  dbchangevalue(&pcontrast,&processbox);
  dbchangevalue(&pgamma,&processbox);
  skipupdate=0;

  makelincurve();
  gammarefresh(0);
  processupdate();
  oldmode=dbpr.mode;
 }


 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}





static os_error * invert(int handle,int userhandle,wimp_mousestr * m)
{
 int i;
 int j;

 for(i=0;i<4;i++)
 {
  for(j=0;j<dbpr.gamman[i];j++)
  {
   dbpr.gammapoint[i][j].y=CMAX-dbpr.gammapoint[i][j].y;
  }
 }

 gammarefresh(0);
 processupdate();

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static char * pname[3][4]=
{
 "R","G","B","",
 "H","S","V","",
 "C","M","Y","K",
};


static os_error * pwriteicons(void)
{
 writeiconc(processbox.handle,17,pname[dbpr.model][0]);
 writeiconc(processbox.handle,18,pname[dbpr.model][1]);
 writeiconc(processbox.handle,19,pname[dbpr.model][2]);
 writeiconc(processbox.handle,20,pname[dbpr.model][3]);
 return(NULL);
}




static int oldmodel;


static os_error * setmodel(int handle,int userhandle,wimp_mousestr * m)
{

 if(oldmodel!=dbpr.model)
 {
  pwriteicons();
  oldmodel=dbpr.model;

  if(dbpr.model!=XPCMYK && dbpr.mode!=XPALL && (dbpr.mode & 0x8))
  {
   dbpr.mode=0x4;
   dbchangevalue(&dbpr.mode,&processbox);
  }

  dbshade(2,dbpr.model==XPCMYK?0:DBSHADEG,&processbox);

  gammarefresh(0);
  processupdate();
 }


 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}




static int oldtool;


static os_error * settool(int handle,int userhandle,wimp_mousestr * m)
{
 if(dbpr.tool!=oldtool)
 {
  makelincurve();

  if(dbpr.tool==XPLIN || oldtool==XPLIN)
    dbshade(1,dbpr.tool==XPLIN?0:(DBSHADEG|DBWRITEG),&processbox);

  oldtool=dbpr.tool;
  gammarefresh(0);
  processupdate();
 }

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * setduo(int handle,int userhandle,wimp_mousestr * m)
{
 processupdate();

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * setupdate(int handle,int userhandle,wimp_mousestr * m)
{
 processupdate();

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * setspots(int handle,int userhandle,wimp_mousestr * m)
{
 processupdate();

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}





static void gupdate(void)
{
 if(!skipupdate)
 {
  putpbrightness();
  makelincurve();
  gammarefresh(0);
  processupdate();

 }
}



static int psnap(int value)
{
 int avalue;

 avalue=ABS(value);
 if(avalue<(0x10000/15)) value=0;

 return(value);
}



static os_error * wrbri(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,0,2));
 return(NULL);
}

static os_error * rdbri(int * value,char * string)
{
 os_error * err;
 err=stringtonumberxdp(string,value,2,2);
 return(err);
}



static os_error * wrcon(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,0,2));
 return(NULL);
}

static os_error * rdcon(int * value,char * string)
{
 os_error * err;
 err=stringtonumberxdp(string,value,2,2);
 return(err);
}




static os_error * wrgam(int value,char * string)
{
 value=gammalocal2absolute(value);
 strcpy(string,numbertostringxdp(value,2,0));
 return(NULL);
}






static os_error * rdgam(int * value,char * string)
{
 os_error * err;
 int        temp;

 err=stringtonumberxdp(string,&temp,2,0);
 if(!err)
 {
  temp=gammaabsolute2local(temp);
  temp=CUT(temp,MINGAM,MAXGAM);   /* crash if real gamma gets to zero */

  *value=temp;
 }

 return(err);
}





static void prsetupdbox(void)
{
 oldtool=dbpr.tool;
 oldmodel=dbpr.model;
 oldmode=dbpr.mode;

 pwriteicons();
 dbshade(2,dbpr.model==XPCMYK?0:DBSHADEG,&processbox);
 dbshade(1,dbpr.tool==XPLIN?0:(DBSHADEG|DBWRITEG),&processbox);

 setpbrightness();

 pactiveupdate(1);
}





static os_error * defprocess(int handle,int userhandle,wimp_mousestr * m)
{
 int oldupdate;

 oldupdate=dbpr.update;
 dbpr=defdbprocess;
 dbpr.update=oldupdate;

 prsetupdbox();

 dbwritevalues(&processbox);

 gammarefresh(0);
 wimp_set_icon_state(processbox.handle,44,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(processbox.handle,47,(wimp_iconflags)0,(wimp_iconflags)0);

 if(oldupdate) processupdate();

 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}





/*
static os_error * processkey(int handle,int userhandle,int icon,int * key)
{
 return(NULL);

 USE(handle);
 USE(icon);
 USE(key);
 USE(userhandle);
}
*/



#define DBRI (MAXBRI/100)
#define DCON (MAXCON/100)
#define DGAM 689







static dbiconstr processicondefs[]=
{

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1,  NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
   2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   52, NULL,         DBACTION, 0,   0,      0, 0, 0, 0,(dbreadfn)defprocess,0,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   16,  &dbpr.mode,  DBRADIO,  0,   0,     XPALL,F1,1,0,(dbreadfn)setmode,NULL,
   17,  &dbpr.mode,  DBRADIO,  0,   0,     1,    F2,1,0,(dbreadfn)setmode,NULL,
   18,  &dbpr.mode,  DBRADIO,  0,   0,     2,    F3,1,0,(dbreadfn)setmode,NULL,
   19,  &dbpr.mode,  DBRADIO,  0,   0,     4,    F4,1,0,(dbreadfn)setmode,NULL,
   20,  &dbpr.mode,  DBRADIO,  2,   0,     8,    F5,1,0,(dbreadfn)setmode,NULL,

   12,  &dbpr.model, DBRADIO,  0,   0,    XPRGB,F6,2,0,(dbreadfn)setmodel,NULL,
   13,  &dbpr.model, DBRADIO,  0,   0,   XPCMYK,F7,2,0,(dbreadfn)setmodel,NULL,
   14,  &dbpr.model, DBRADIO,  0,   0,    XPHSV,F8,2,0,(dbreadfn)setmodel,NULL,

    5,  &dbpr.tool,  DBRADIO,  0,   0,    XPLIN,F8,3,0,(dbreadfn)settool, NULL,
    7,  &dbpr.tool,  DBRADIO,  0,   0,    XPSTR,F8,3,0,(dbreadfn)settool, NULL,
    8,  &dbpr.tool,  DBRADIO,  0,   0,    XPCUR,F8,3,0,(dbreadfn)settool, NULL,



   42,  &dbpr.duotone,DBTOGGLE, 0,   0,  1,  F5, 0, 0,(dbreadfn)setduo,NULL,
   49,  &dbpr.update, DBTOGGLE, 0,   0,  1,  F5, 0, 0,(dbreadfn)setupdate,NULL,
//   53,  &dbpr.usespots,DBTOGGLE,0,   0,  1,  F5, 0, 0,(dbreadfn)setspots,NULL,


 /* N   &V           Type     Grp   Flags     R   L   D   U     In    Out */

   25,  &pbrightness,DBWRITE,  1,DBEDITCHANGE|DBASSOCINC, 32, 39, 32, 39,  rdbri, wrbri,
   32,  &pcontrast,  DBWRITE,  1,DBEDITCHANGE|DBASSOCINC, 39, 25, 39, 25,  rdcon, wrcon,
   39,  &pgamma,     DBWRITE,  1,DBEDITCHANGE|DBASSOCINC, 25, 32, 25, 32,  rdgam, wrgam,


    9,  &dbpr.inverted, DBTOGGLE, 0,   0,   1,  F4, 0,0,(dbreadfn)invert,NULL,


 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */
 /* N   &V           Type      Grp   Flags   link   -   max  min  -      - */

   23, &pbrightness,DBSLIDER,1,  0,       1,  -1,  MAXBRI,MINBRI,NULL,
                                                             (dbwritefn)psnap,

   27, &pbrightness,DBINC   ,1,  0,    DBRI,  -1,  MAXBRI,MINBRI,NULL,  0,
   26, &pbrightness,DBDEC   ,1,  0,    DBRI,  -1,  MAXBRI,MINBRI,NULL,  0,


   30, &pcontrast,  DBSLIDER,1,  0,       1,   -1, MAXCON,MINCON,NULL,  
                                                             (dbwritefn)psnap,

   34, &pcontrast,  DBINC   ,1,  0,    DCON,   -1, MAXCON,MINCON,NULL,  0,
   33, &pcontrast,  DBDEC   ,1,  0,    DCON,   -1, MAXCON,MINCON,NULL,  0,


   37, &pgamma,     DBSLIDER,1,  0,       1,   -1, MAXGAM,MINGAM,NULL,  
                                                             (dbwritefn)psnap,

   41, &pgamma,     DBINC   ,1,  0,    DGAM,   -1, MAXGAM,MINGAM,NULL,  0,
   40, &pgamma,     DBDEC   ,1,  0,    DGAM,   -1, MAXGAM,MINGAM,NULL,  0,


   GRIDICON,&pbrightness,DBUPDATE, 0, 0,  0,  0,0,0,(dbreadfn)gupdate,NULL,
   GRIDICON,&pcontrast,  DBUPDATE, 0, 0,  0,  0,0,0,(dbreadfn)gupdate,NULL,
   GRIDICON,&pgamma,     DBUPDATE, 0, 0,  0,  0,0,0,(dbreadfn)gupdate,NULL,


   21, &pbrightness,DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,
   22, &pbrightness,DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,
   28, &pcontrast,  DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,
   29, &pcontrast,  DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,
   35, &pgamma,     DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,
   36, &pgamma,     DBTEXT, 1,  0,       -1, -1, -1, -1, NULL, NULL,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




extern dboxstr processbox=
{
 0,
 TPROCESS,
 DBFIX,
 DBUPDATEEDIT,
 processclose,
 processicon,
 NULL, //processkey,
 processredraw,
 processicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};












/* script function opens the picture dialogue box */

void openprocessbox(int fp)
{
 os_error      * err;


 err=dbclear(&processbox);
	if(!err)
	{
  cview=getmenuview();
  cfile=cview->file;;

  err=pixselected(&cpictbox,cfile);
		if(!err)
		{
   getselection(&cpage,&csection,NULL,NULL);

   err=getprocess(&dbpr,cpictbox,&cprocess,&ctagfound,cfile);
			if(!err)
			{
    if(cprocess && ctagfound) cdbpr=dbpr;

    setpbrightness();   /* ensure values set up before dodbox() write them */

    err=dodboxspparent(&processbox,1,&processbox,getviewstack(),cview->handle);
    if(!err) prsetupdbox();
			}
		}
 }

 zreport(err);
}

