/*->c.fillgrad */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 
#include <limits.h>

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"


#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "colour.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "xmath.h"
#include "deb.h"
#include "sprx.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "prstr.h"
#include "xprint.h"



#include "units.h"

#include "object.h"
#include "select.h"
#include "xredraw.h"
#include "curve.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "dbcolour.h"
#include "mhi.h"
#include "dscript.h"

#include "geometry.h"

#include "splib.h"

#include "colsep.h"





#include "filllink.h"

#include "filltool.h"
#include "dbfill.h"
#include "fill.h"
#include "fillcol.h"
#include "iptab.h"


#include "fillgrad.h"


extern int getmatch(int * paltab,int * endtab,int pal);



#define MINRAD (MMRUNITS(1,2))



/***************************************************************************/


#define DMSIZE  16
#define DMLIMIT (DMSIZE*DMSIZE)



/*
static int magic4x4[4][4]=
{
  0, 14,  3, 13,
 11,  5,  8,  6,
 12,  2, 15,  1,
  7,  9,  4, 10
};
*/

static int dither8[16*16] = {
      1,235, 59,219, 15,231, 55,215,  2,232, 56,216, 12,228, 52,212,
    129, 65,187,123,143, 79,183,119,130, 66,184,120,140, 76,180,116,
     33,193, 17,251, 47,207, 31,247, 34,194, 18,248, 44,204, 28,244,
    161, 97,145, 81,175,111,159, 95,162, 98,146, 82,172,108,156, 92,
      9,225, 49,209,  5,239, 63,223, 10,226, 50,210,  6,236, 60,220,
    137, 73,177,113,133, 69,191,127,138, 74,178,114,134, 70,188,124,
     41,201, 25,241, 37,197, 21,255, 42,202, 26,242, 38,198, 22,252,
    169,105,153, 89,165,101,149, 85,170,106,154, 90,166,102,150, 86,
      3,233, 57,217, 13,229, 53,213,  0,234, 58,218, 14,230, 54,214,
    131, 67,185,121,141, 77,181,117,128, 64,186,122,142, 78,182,118,
     35,195, 19,249, 45,205, 29,245, 32,192, 16,250, 46,206, 30,246,
    163, 99,147, 83,173,109,157, 93,160, 96,144, 80,174,110,158, 94,
     11,227, 51,211,  7,237, 61,221,  8,224, 48,208,  4,238, 62,222,
    139, 75,179,115,135, 71,189,125,136, 72,176,112,132, 68,190,126,
     43,203, 27,243, 39,199, 23,253, 40,200, 24,240, 36,196, 20,254,
    171,107,155, 91,167,103,151, 87,168,104,152, 88,164,100,148, 84 };




/* basic dithering macro */

#define DMAP(v,x,y)     (modN[v]>magic[x+y] ? divN[v] + 1 : divN[v])
#define GDMAP(v,x,y)    (grmodN[v]>grmagic[x+y] ? grdivN[v] + 1 : grdivN[v])



#define DMMAP(mod,div,v,x,y) (mod[v]>magic[x+y] ? div[v] + 1 : div[v])
#define GDMMAP(mod,div,v,x,y) (mod[v]>grmagic[x+y] ? div[v] + 1 : div[v])

static void make_square(int levels,char * divN,char * modN,
                                       char * magic,int * dither,int side)
{
 int     i;
 int     j;
 int     magicn;
 int     magicd;


 /* N=255/(levels-1) */

 for(i=0;i<256;i++)
 {
  divN[i]=(i*(levels-1))/255;
  modN[i]=i-(255*divN[i])/(levels-1);
 }
 modN[255]=0;    /* always */

    /*
     * Expand 4x4 dither pattern to 16x16.  4x4 leaves obvious patterning,
     * and doesn't give us full intensity range (only 17 sublevels).
     * 
     * magicfact is (N - 1)/16 so that we get numbers in the matrix from 0 to
     * N - 1: mod N gives numbers in 0 to N - 1, don't ever want all
     * pixels incremented to the next level (this is reserved for the
     * pixel value with mod N == 0 at the next level).
     */

/* magicfact=(N-1)/((double)side*(double)side); */

 /* magicfact=(255-(levels-1))/((levels-1)*side*side)  */

 magicn=(255-(levels-1));
 magicd=((levels-1)*side*side);

 for(i=0;i<side;i++)
 {
  for(j=0;j<side;j++)
  {
   /* magic[i*side+j]=(int)(0.5+dither[i*side+j]*magicfact); */

   magic[i*side+j]=(dither[i*side+j]*magicn+magicd/2)/magicd;
  }
 }
}






/*
 * Algorithm:
 *      Compute gamma compensation map.
 *      N = 255.0 / (levels - 1) is number of pixel values per level.
 *      Compute bwmap for levels entries.
 *      Call make_square to get divN, modN, and magic.
 * Note:
 *      Call ditherbw( x, y, val, divN, modN, magic ) to get index into 
 *      bwmap for a given color/location pair, or use
 *          row = y % 16; col = x % 16;
 *          divN[val] + (modN[val]>magic[col][row] ? 1 : 0)
 *      if you don't want function call overhead.
 *      On a 1-bit display, use
 *          divN[val] > magic[col][row] ? 1 : 0
 */









static char modN[256];
static char divN[256];
static char magic[DMSIZE*DMSIZE];

static char grmodN[256];
static char grdivN[256];
static char grmagic[DMSIZE*DMSIZE];


#ifdef NEVER

static os_error * getospal(int * dpal,int * nc,int * bpp)
{
 os_error * err;
 os_regset  rx;
 int        pal[256];
 int        i;
 int        c1;
 int        dbpp;
 vdustr   * cvdu;


 err=NULL;

 cvdu=getcvdu();

 *bpp=dbpp=1<<cvdu->ln2bpp;
 *nc=(1<<dbpp);

 if(cvdu->ln2bpp==3)
 {
  if(cvdu->ncolours==63) c1=16;
  else                   c1=256;

  for(i=0;i<c1;i++)
  {
   rx.r[0]=i;
   rx.r[1]=16;
//   os_swix(OS_ReadPalette,&rx);
   pal[i]=rx.r[2];
  }
 }

 if(dbpp<=8)
 {
  for(i=0;i<(1<<dbpp);i++)
  {
   if(cvdu->ncolours==63)
   {
    c1=pal[i & 0xF] & 0xFFFFFF00;

    if(i & 0x10) c1|=0x8000;
    else         c1&=~0x8000;

    if(i & 0x20) c1|=0x400000;
    else         c1&=~0x400000;

    if(i & 0x40) c1|=0x800000;
    else         c1&=~0x800000;

    if(i & 0x80) c1|=0x80000000;
    else         c1&=~0x80000000;

    c1&=0xF0F0F000;
    c1|=(c1>>4)&0xF0F0F00;

    dpal[i]=c1;
   }
   else
   if(cvdu->ncolours==255) dpal[i]=pal[i];
   else 
   dpal[i]=cvdu->vdupal.c[i].word;
  }
 }

 return(err);
}



#endif


static int ngreypal(int * pal,int ncolours)
{
 int i;
 int r;
 int g;
 int b;
 int ng;

 ng=0;

 for(i=0;i<ncolours;i++)
 {
  r=(pal[i]>>8)  & 0xFF;
  g=(pal[i]>>16) & 0xFF;
  b=(pal[i]>>24) & 0xFF;
  if(r==g && g==b) ng++;

//  xcprintf("r %x g %x b %x",r,g,b);
 }

 return(ng);
}




#define REDWEIGHT   299
#define GREENWEIGHT 587
#define BLUEWEIGHT  114




static int makegrey2(int word)
{
 int r;
 int g;
 int b;

 r=(word)  & 0xFF;
 g=(word>>8) & 0xFF;
 b=(word>>16) & 0xFF;

 word=(r*REDWEIGHT+g*GREENWEIGHT+b*BLUEWEIGHT)/
                                          (REDWEIGHT+GREENWEIGHT+BLUEWEIGHT);
 return((word)|(word<<8)|(word<<16));
}


static int greyentry2(int word)
{
 int r;
 int g;
 int b;

 r=(word)  & 0xFF;
 g=(word>>8) & 0xFF;
 b=(word>>16) & 0xFF;

 return(r==g && g==b);
}




/***************************************************************************/

/* grey map is an array of bytes, index in with 0..255, get out pal entry */


typedef struct gval
{
 int value;
 int index;

} gval;


static int cmpbyte(const void * p1,const void * p2)
{
 int w1;
 int w2;

 w1=((gval*)p1)->value;
 w2=((gval*)p2)->value;

 return(w1-w2);
}


static os_error * makegmap(int colours,int *colourmap,
                                                    char * greymap,int * size)
{
 gval tempmap[256];
 int  i;
 int  j;
 int  ngrey;
 int  r;
 int  g;
 int  b;

 ngrey=0;

 for(i=0;i<colours;i++) 
 {
  r=(colourmap[i]>> 8)&0xFF;
  g=(colourmap[i]>>16)&0xFF;
  b=(colourmap[i]>>24)&0xFF;

  if(r==g && g==b)
  {
   tempmap[ngrey].value=r;
   tempmap[ngrey++].index=i;
  }
 }

 qsort(tempmap,ngrey,sizeof(gval),cmpbyte);


 /* strip duplicates */

 j=0;
 for(i=0;i<ngrey;i++)
 {
  if(i>0 && tempmap[i].value==tempmap[i-1].value) {}
  else
  {
   tempmap[j]=tempmap[i];
   j++;
  }
 }
 ngrey=j;


 j=0;

 for(i=0;i<256;i++)
 {
  if(j==(ngrey-1)) greymap[i]=tempmap[j].index;
  else
  {
   while(((ABS(i-tempmap[j].value))>(ABS(tempmap[j+1].value-i)))
                                                       && j<(ngrey-1)) j++;
   greymap[i]=tempmap[j].index;
  }
 }


 *size=ngrey;

 return(NULL);
}



/**************************************************************************/


typedef struct gradstr
{
 colourvalue   fc;
 colourvalue   tc;
 int           type;
 int           x;
 int           y;
 int           rx;
 int           ry;
 int           angle;
 int           skew;

 int           spare[12];

} gradstr;


#define GRLIN  0x0
#define GRBLIN 0x1
#define GRQLIN 0x2
#define GRRAD  0x3



static gradstr defgrad=
{
 OURBLACK,
 OURWHITE,
 GRLIN,
 0,
 0,
 MMUNITS(100),
 MMUNITS(100),
 0,
 0,

 0,0,0,0,0,0,
 0,0,0,0,0,0,

};



static gradstr cgrad;
static int     cx;
static int     cy;
static int     cangle;
static int     cskew;


/*************************************************************************/

static int level1;
static int level2;
static int greymode;
static int glevels;

#ifdef NEVER

static int ospal[256];
static int osnc;
static int osbpp;

#endif

static int osmode;


static char palmap[8*8*8];
static char gpalmap[256];



#define CM16L1 5
#define CM16L2 10




static void createdithermap(int * pstart,int bpp,int nc)
{
 int      levels;
 int      ri;
 int      gi;
 int      bi;
 int      r;
 int      g;
 int      b;
/* double   N; */
 int      p;
 int      index;
 int    * pend;  
 int      ng;
 char     greymap[256];


 greymode=glevels=0;

 if(bpp<32)
 {
  if(bpp==16)  
  {
   levels=32;
   level1=5;
   level2=10;
   make_square(levels,divN,modN,magic,dither8,DMSIZE);
  }
  else
  {
   pend=pstart+nc-1;

   ng=ngreypal(pstart,nc);

//   xcprintf("ng %d",ng);

   greymode=(ng==nc);
   glevels=ng;


   if(glevels)
   {
    makegmap(nc,pstart,greymap,&ng);
    /* N=255.0/((double)(ng-1)); */
    make_square(glevels,grdivN,grmodN,grmagic,dither8,DMSIZE);

    for(gi=0;gi<ng;gi++)
    {
     /* g=(int)(0.5+gi*N); */
     g=(255*gi)/(ng-1);
     gpalmap[gi]=greymap[g];
    }
   }


   if(!greymode)
   {
    if(bpp==8)
    {
     levels=5;
     level1=3;
     level2=6;
    }
    else
    {
     levels=2;
     level1=1;
     level2=2;
    }

    /* N=255.0/((double)(levels-1)); */   /* Get size of each step */
    make_square(levels,divN,modN,magic,dither8,DMSIZE);


    for(ri=0;ri<levels;ri++)
    {
     /* r=(int)(0.5+ri*N); */
     r=(ri*255)/(levels-1);
     for(gi=0;gi<levels;gi++)
     {
      /* g=(int)(0.5+gi*N); */
      g=(gi*255)/(levels-1);
      for(bi=0;bi<levels;bi++)
      {
       /* b=(int)(0.5+bi*N); */
       b=(bi*255)/(levels-1);

       index=getmatch(pstart,pend,(b<<24)|(g<<16)|(r<<8));

       p=ri+(gi<<level1)+(bi<<level2);
       palmap[p]=index;
      }
     }
    }
   }
  }
 }
}




static os_error * fillmode(wimp_msgstr * msg,int * ack)
{
// getospal(ospal,&osnc,&osbpp);
 osmode=-1;

 return(NULL);
 USE(ack);
 USE(msg);
}




/* if output palette is GS, convert fill levels to GS  */
/* if fill is GS, look at how many GS levels there are */



static void initdithermap2(splibstr * sp,int * grey,int * table)
{
// int * from;
// int * to;
 int   paltab[256];
 int   palentries;
 int   i;


 *grey=0;

 if(sp->sbpp<32)
 {
  if((sp->sflags & (SP_GREY|SP_PALETTE)) && osmode!=0)
  {
//   xcprintf("init dither 1");
   
   spgetpal((newsprite_header*)sp->spa,&palentries,paltab);
   genpal256(paltab,ln2(sp->sbpp),&palentries);

   createdithermap(paltab,sp->sbpp,palentries);
//   xcprintf("palentries %d ln2 %d",palentries,ln2(sp->sbpp));

   osmode=0;
  }
  else
  if(!(sp->sflags & (SP_GREY|SP_PALETTE)) && osmode!=1)
  {
//   xcprintf("init dither 2");

//   createdithermap(ospal,osbpp,osnc);
   osmode=1;
  }

  if(greyentry2(table[0]) && greyentry2(table[255])) *grey=glevels;

  if(greymode && !(*grey)) 
  {
   for(i=0;i<256;i++)
   {
    table[i]=makegrey2(table[i]);
   }
   *grey=glevels;
  }
 }
}






static int  colourtable[256];

static char rmodN[256];
static char gmodN[256];
static char bmodN[256];

static char rdivN[256];
static char gdivN[256];
static char bdivN[256];



int fillgetcolour(int fp)
{
 int * stack;

 stack=xstackptr();

 return(colourtable[stack[fp]]);
}




static void inittables(colourvalue * fc,colourvalue * tc,splibstr * sp,
                         viewstr * view,int * doproc,int * grey)
{
 int i;
 int v;
 int r;
 int g;
 int b;


// xcprintf("inittables");

 filltableinit(fc,tc,view,doproc,colourtable,0,NULL);
 initdithermap2(sp,grey,colourtable);


 if(*grey)
 {
  for(i=0;i<256;i++)
  {
   r=colourtable[i] & 0xFF;
   rmodN[i]=grmodN[r];
   rdivN[i]=grdivN[r];
  }
 }
 else
 {
  for(i=0;i<256;i++)
  {
   v=colourtable[i];
   r=v&0xFF;
   g=(v>>8)&0xFF;
   b=(v>>16)&0xFF;

   rmodN[i]=modN[r];
   rdivN[i]=divN[r];
   gmodN[i]=modN[g];
   gdivN[i]=divN[g];
   bmodN[i]=modN[b];
   bdivN[i]=divN[b];
  }
 }
}



/****************************************************************************/

#ifdef NEVER

static char iptab[0x8000];
static char iptab2[256];


static void initradialtable(void)
{
 int x;
 int y;
 int n;
 char * p;

 for(y=0;y<256;y++)
 {
  for(x=0;x<y;x++)
  {
   n=squareroot(x*x+y*y,0);
   if(n>255) n=255;
   if(y<128)
   {
    *(iptab+x+y*256)=n;
   }
   else 
   {
    *(iptab+255-x+(255-y)*256)=n;
   }
  }

  n=squareroot(2*y*y,0);
  if(n>255) n=255;

  iptab2[y]=n;
 }

 p=iptab;

 printf("char iptab[0x8000]=\n");
 printf("{\n");
 for(y=0;y<128;y++)
 {
  for(x=0;x<256;x++)
  {
   printf("%d,",*p++);
  }
  printf("\n");
 }
 printf("};\n");

 printf("\n\n\n");

 p=iptab2;

 printf("char iptab2[256]=\n");
 printf("{\n");
 for(y=0;y<256;y++)
 {
  printf("%d,",*p++);
 }

 printf("};\n");
 printf("\n\n\n");

}

#endif












static os_error * gradrad(gradstr * grad,transformstr * irestr,
                          aboxstr * abox,viewstr * view)
{
 int             x;
 int             y;
 splibstr      * sp;
 coordstr        cx[2];
 int             yc;
 int           * sdata;
 int           * sdata2;
 int             width;
 int             fx;
 int             fdeltax;
 int             fy;
 int             fdeltay;
 int             pal;
 int             w;
 int             shift;
 int             xmaxr;
 int             ymaxr;
 int             grey;

 int             row;
 int             col;
 int             doproc;
 int             dfx;
 int             dfy;
 int             i;
 int             ix;
 int             iy;

 sp=sp_getsp();

 inittables(&grad->fc,&grad->tc,sp,view,&doproc,&grey);

 if(!(doproc & FILLTABLENULL))
 {
  yc=abox->y1;

  sdata2=(int*)(((char*)sp->spa)+(sp->spa)->image);
  width=((sp->sxpix*sp->sbpp+31) & (~31))>>3;

  xmaxr=grad->rx;
  ymaxr=grad->ry;

  row=0;


  cx[0].x=abox->x0<<8;
  cx[1].x=abox->x1<<8;
  cx[0].y=cx[1].y=yc<<8;

  tr_transformset(cx,2,irestr);

  fdeltax=(cx[1].x-cx[0].x)/sp->sxpix;
  fdeltay=(cx[1].y-cx[0].y)/sp->sxpix;

  dfx=scale(0x10000,fdeltax,xmaxr);
  dfy=scale(0x10000,fdeltay,ymaxr);

  for(y=0;y<sp->sypix;y++)
  {
   cx[0].x=abox->x0<<8;
   cx[0].y=yc<<8;

   tr_transformset(cx,1,irestr);

   fx=scale(0x10000,cx[0].x,xmaxr);
   fy=scale(0x10000,cx[0].y,ymaxr);


   col=0;

   sdata=sdata2;
   w=shift=0;

   for(x=0;x<sp->sxpix;x++)
   {
    if(fx>=0) ix=fx;
    else      ix=-fx;

    if(fy>=0) iy=fy;
    else      iy=-fy;

    if(ix>=0x10000 || iy>=0x10000) i=255;
    else
    {
     ix=ix>>8;
     iy=iy>>8;

     if(ix==iy)
     {
      i=*(iptab2+ix);
     }
     else
     if(ix>=iy)
     {
      if(ix>=0x80)
      {
       i=*(iptab-(iy)+(0xFF00-(ix<<8))+255);
      }
      else
      {
       i=*(iptab+(iy)+(ix<<8));
      }
     }
     else
     {
      if(iy>=0x80)
      {
       i=*(iptab-(ix)+(0xFF00-(iy<<8))+255);
      }
      else
      {
       i=*(iptab+(ix)+(iy<<8));
      }
     }
    }

    fx+=dfx;
    fy+=dfy;


    if(grey)
    {
     pal=(GDMMAP(rmodN,rdivN,i,col,row));
     pal=gpalmap[pal];

     w|=pal<<shift;
     shift+=sp->sbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp<=8)
    {
     pal=(DMMAP(rmodN,rdivN,i,col,row))+
         ((DMMAP(gmodN,gdivN,i,col,row))<<level1)+
         ((DMMAP(bmodN,bdivN,i,col,row))<<level2); 

     pal=palmap[pal];

     w|=pal<<shift;
     shift+=sp->sbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp==16)
    {
     pal=(DMMAP(rmodN,rdivN,i,col,row))+
         ((DMMAP(gmodN,gdivN,i,col,row))<<level1)+
         ((DMMAP(bmodN,bdivN,i,col,row))<<level2); 
                             /*((r&0xF8)>>3)|((g&0xF8)<<2)|((b&0xF8)<<7); */
     w|=pal<<shift;
     shift+=16;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp==32)
    {
     *sdata++=colourtable[i] & 0xFFFFFF;
    }
    if(++col>=DMSIZE) col=0;
   }

   sdata2=(int*)((char*)sdata2+width);
   //yc-=180/sp->sydpi;

   yc=abox->y1+scale((abox->y0-abox->y1),y,(sp->sypix-1));

   row+=DMSIZE;
   if(row>=DMLIMIT) row=0;
  }
 }

 return(NULL);
}









static os_error * gradqlin(gradstr * grad,transformstr * irestr,
                          aboxstr * abox,viewstr * view)
{
 int             x;
 int             y;
 splibstr      * sp;
 coordstr        cx[2];
 int             yc;
 int           * sdata;
 int           * sdata2;
 int             width;
 int             fx;
 int             fdeltax;
 int             fy;
 int             fdeltay;
 int             pal;
 int             w;
 int             shift;
 int             xmaxr;
 int             ymaxr;
 int             grey;

 int             row;
 int             col;
 int             doproc;
 int             dfx;
 int             dfy;
 int             i;


 sp=sp_getsp();

 inittables(&grad->fc,&grad->tc,sp,view,&doproc,&grey);

 if(!(doproc & FILLTABLENULL))
 {
  yc=abox->y1;

  sdata2=(int*)(((char*)sp->spa)+(sp->spa)->image);
  width=((sp->sxpix*sp->sbpp+31) & (~31))>>3;
 
  xmaxr=grad->rx;
  ymaxr=grad->ry;

  row=0;


  cx[0].x=abox->x0<<8;
  cx[1].x=abox->x1<<8;
  cx[0].y=cx[1].y=yc<<8;

  tr_transformset(cx,2,irestr);

  fdeltax=(cx[1].x-cx[0].x)/sp->sxpix;
  fdeltay=(cx[1].y-cx[0].y)/sp->sxpix;

  dfx=scale(0x10000,fdeltax,xmaxr);
  dfy=scale(0x10000,fdeltay,ymaxr);

  for(y=0;y<sp->sypix;y++)
  {
   cx[0].x=abox->x0<<8;
   cx[0].y=yc<<8;

   tr_transformset(cx,1,irestr);

   fx=scale(0x10000,cx[0].x,xmaxr);
   fy=scale(0x10000,cx[0].y,ymaxr);


   col=0;

   sdata=sdata2;
   w=shift=0;

   for(x=0;x<sp->sxpix;x++)
   {
    if(fx>=0)
    {
     if(fy>=0)
     {
      i=(fx+fy);
     }
     else
     {
      i=(fx-fy);
     }
    }
    else
    {
     if(fy>=0)
     {
      i=(-fx+fy);
     }
     else
     {
      i=(-fx-fy);
     }
    }

    if(i>=0x10000) i=255;
    else           i=i>>8;

    fx+=dfx;
    fy+=dfy;


    if(grey)
    {
     pal=(GDMMAP(rmodN,rdivN,i,col,row));
     pal=gpalmap[pal];

     w|=pal<<shift;
     shift+=sp->sbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp<=8)
    {
     pal=(DMMAP(rmodN,rdivN,i,col,row))+
         ((DMMAP(gmodN,gdivN,i,col,row))<<level1)+
         ((DMMAP(bmodN,bdivN,i,col,row))<<level2); 

     pal=palmap[pal];

     w|=pal<<shift;
     shift+=sp->sbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp==16)
    {
     pal=(DMMAP(rmodN,rdivN,i,col,row))+
         ((DMMAP(gmodN,gdivN,i,col,row))<<level1)+
         ((DMMAP(bmodN,bdivN,i,col,row))<<level2); 
                             /*((r&0xF8)>>3)|((g&0xF8)<<2)|((b&0xF8)<<7); */
     w|=pal<<shift;
     shift+=16;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }
    }
    else
    if(sp->sbpp==32)
    {
     *sdata++=colourtable[i] & 0xFFFFFF;
    }
    if(++col>=DMSIZE) col=0;
   }

   sdata2=(int*)((char*)sdata2+width);
//   yc-=180/sp->sydpi;
   yc=abox->y1+scale((abox->y0-abox->y1),y,(sp->sypix-1));

   row+=DMSIZE;
   if(row>=DMLIMIT) row=0;
  }
 }

 return(NULL);
}




/* abox   - area in OS units to render                 */
/* restr  - transform from fill space to Draw/OS space */
/* filltr - transform from fill space to page space    */
/* ctr    - transform from curve space to page space   */


static os_error * gradlind(gradstr * grad,transformstr * restr,
                                          transformstr * irestr,
                           viewredrawstr * v,aboxstr * abox,int * dorenderfill)
{
 os_error * err;
 aboxstr    dbox;
 aboxstr    maxbox;
 int        result;
 int        doproc;
 viewstr  * view;
	int        model;	// colour model 1==RGB, 2==CMYK, 0==Grey

	model=1;


 view=v->view;


 err=filltableinit(&grad->fc,&grad->tc,view,&doproc,colourtable,FILLTABLECMYK,&model);
 if(!err)
 {

/*
  Not sure why we're doing this. It will be wrong if CMYK table returned

  if(!(((prjobstr*)v->prjob)->bits & PRCOLOUR) && model!=GREYMODEL)
  {
   for(i=0;i<256;i++)
   {
    colourtable[i]=makegrey2(colourtable[i]);
   }
  }
*/

  if(!(doproc & FILLTABLENULL))
  {
			if((((prjobstr*)v->prjob)->prtype==PRPS) && (((prjobstr*)v->prjob)->bits & PSDIRECT))
			{
    dbox=*abox;

    dbox.x0*=256;
    dbox.x1*=256;
    dbox.y0*=256;
    dbox.y1*=256;

    getmaxabox(&maxbox,&dbox,irestr);

    err=xexec("fill_code",&result,"IIIIIIIIIIIIII/R",
                                         grad->type,
                                         restr->a,
                                         restr->b,
                                         restr->c,
                                         restr->d,
                                         restr->e,
                                         restr->f,
                                         grad->rx,
                                         grad->ry,
                                         maxbox.x0,
                                         maxbox.y0,
                                         maxbox.x1,
                                         maxbox.y1,model,dorenderfill);
   }
		}
		else
		{
			*dorenderfill=0;
		}
 }

 return(err);
}





static os_error * gradlin(gradstr * grad,transformstr * irestr,
                          aboxstr * abox,viewstr * view)
{
 int             y;
 splibstr      * sp;
 coordstr        cx[2];
 int             yc;
 int           * sdata;
 int           * sdata2;
 int             width;
 int             fx;
 int             deltax;
 int             f;
 int             df;

 int             w;
 int             shift;
 int             minr;
 int             maxr;
 int             grey;

 char          * rowp;
 char          * colp;
 int             m;
 char          * rowpl;
 char          * colpl;
 int             spbpp;
 char          * lmagic;

 int             doproc;
 int             i;


 sp=sp_getsp();
 spbpp=sp->sbpp;


 inittables(&grad->fc,&grad->tc,sp,view,&doproc,&grey);


 if(!(doproc & FILLTABLENULL))
 {

  yc=abox->y1;

  sdata2=(int*)(((char*)sp->spa)+(sp->spa)->image);
  width=((sp->sxpix*sp->sbpp+31) & (~31))>>3;

  maxr=grad->rx;

  if(grad->type==GRBLIN) minr=-maxr;
  else                   minr=0;


  if(grey) lmagic=grmagic;
  else     lmagic=magic;

  rowp=lmagic;
  rowpl=lmagic+DMLIMIT;


  cx[0].x=abox->x0<<8;
  cx[1].x=abox->x1<<8;
  cx[0].y=cx[1].y=yc<<8;

  tr_transformset(cx,2,irestr);


  deltax=cx[1].x-cx[0].x;

  deltax=deltax/sp->sxpix;

  df=scale(0x10000,deltax,maxr);

  for(y=0;y<sp->sypix;y++)
  {
   cx[0].x=abox->x0<<8;
   cx[0].y=yc<<8;

   tr_transformset(cx,1,irestr);

   fx=cx[0].x;
   f=scale(0x10000,fx,maxr);

   colp=rowp;
   colpl=rowp+DMSIZE;

   sdata=sdata2;
   w=shift=0;
   sdata2=(int*)((char*)sdata2+width);


   if(grey)
   {
    while(sdata<sdata2)
    {
     if(f>=0)
     {
      if(f<0x10000) i=(f>>8)&0xFF;
      else          i=255;
     }
     else
     {
      if(minr==0) i=0;
      else
      {
       if(f>-0x10000) i=((-f)>>8)&0xFF;
       else           i=255;
      }
     }

     m=*colp;

     w|=gpalmap[(rmodN[i]>m)?(rdivN[i]+1):rdivN[i]]<<shift;

     shift+=spbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }

     f+=df;

     if(++colp>=colpl) colp=rowp;
    }
   }
   else
   if(spbpp<=8)
   {
    while(sdata<sdata2)
    {
     if(f>=0)
     {
      if(f<0x10000) i=(f>>8)&0xFF;
      else          i=255;
     }
     else
     {
      if(minr==0) i=0;
      else
      {
       if(f>-0x10000) i=((-f)>>8)&0xFF;
       else           i=255;
      }
     }

     m=*colp;

     w|=palmap[(((rmodN[i]>m)?(rdivN[i]+1):rdivN[i])+
               (((gmodN[i]>m)?(gdivN[i]+1):gdivN[i])<<level1)+
               (((bmodN[i]>m)?(bdivN[i]+1):bdivN[i])<<level2))]<<shift;

     shift+=spbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }

     f+=df;

     if(++colp>=colpl) colp=rowp;
    }
   }
   else
   if(spbpp==16)
   {
    while(sdata<sdata2)
    {
     if(f>=0)
     {
      if(f<0x10000) i=(f>>8)&0xFF;
      else          i=255;
     }
     else
     {
      if(minr==0) i=0;
      else
      {
       if(f>-0x10000) i=((-f)>>8)&0xFF;
       else           i=255;
      }
     }

     m=*colp;

     w|=(((rmodN[i]>m)?(rdivN[i]+1):rdivN[i])+
        (((gmodN[i]>m)?(gdivN[i]+1):gdivN[i])<<CM16L1)+
        (((bmodN[i]>m)?(bdivN[i]+1):bdivN[i])<<CM16L2))<<shift;

     shift+=16;
     if(shift>=32)
     {
      *sdata++=w;
      w=shift=0;
     }

     f+=df;

     if(++colp>=colpl) colp=rowp;
    }
   }
   else
   {
    while(sdata<sdata2)
    {
     if(f>=0)
     {
      if(f<0x10000) i=(f>>8)&0xFF;
      else          i=255;
     }
     else
     {
      if(minr==0) i=0;
      else
      {
       if(f>-0x10000) i=((-f)>>8)&0xFF;
       else           i=255;
      }
     }

     *sdata++=colourtable[i] & 0xFFFFFF;

     f+=df;
    }
   }

//   yc-=180/sp->sydpi;
   yc=abox->y1+scale((abox->y0-abox->y1),y,(sp->sypix-1));

   rowp+=DMSIZE;
   if(rowp>=rowpl) rowp=lmagic;
  }
 }

 return(NULL);
}




/* abox   - area in OS units to render                 */
/* restr  - transform from fill space to Draw/OS space */
/* filltr - transform from fill space to page space    */
/* ctr    - transform from curve space to page space   */


static os_error * gradrender(aboxstr * abox,transformstr * restr,
                             transformstr * filltr,
                             viewredrawstr * v,curvestr * c,
                             curvestylestr * cstyle,transformstr * ctr)

{
 os_error      * err;
 fillobjectstr * fillp;
 gradstr         grad;
 filestr       * file;
 viewstr       * view;
 transformstr    irestr;

 err=NULL;


 file=v->file;
 view=v->view;


 tr_inverse(restr,&irestr);


 fillp=(fillobjectstr*)fob_find(cstyle->fill.fill,file);
 XMEMCPYX(&grad,((char*)fillp)+sizeof(fillobjectstr),sizeof(gradstr));


 switch(grad.type)
 {
  case     GRLIN:
  case    GRBLIN:
                 err=gradlin(&grad,&irestr,abox,view);  
                 break;

  case    GRQLIN:
                 err=gradqlin(&grad,&irestr,abox,view);
                 break;

  case     GRRAD:
                 err=gradrad(&grad,&irestr,abox,view);
                 break;
 }


 return(err);

 USE(ctr);
 USE(c);
 USE(filltr);
}






/* abox   - area in OS units to render                 */
/* restr  - transform from fill space to Draw/OS space */
/* filltr - transform from fill space to page space    */
/* tr     - transform from curve space to page space   */



static os_error * gradrenderd(aboxstr * abox,transformstr * restr,
                             transformstr * filltr,
                             viewredrawstr * v,curvestr * c,
                             curvestylestr * cstyle,transformstr * ctr,
                             int * dorenderfill)

{
 os_error      * err;
 fillobjectstr * fillp;
 gradstr         grad;
 filestr       * file;
 viewstr       * view;
 transformstr    irestr;

 err=NULL;


 if(v->isprinter)
 {
  file=v->file;
  view=v->view;

  tr_inverse(restr,&irestr);

  fillp=(fillobjectstr*)fob_find(cstyle->fill.fill,file);
  XMEMCPYX(&grad,((char*)fillp)+sizeof(fillobjectstr),sizeof(gradstr));


  switch(grad.type)
  {
   case     GRLIN:
   case    GRBLIN:
   case    GRQLIN:
   case     GRRAD:
                  err=gradlind(&grad,restr,&irestr,v,abox,dorenderfill);  
                  break;
  }
 }

 return(err);

 USE(ctr);
 USE(c);
 USE(filltr);
}









static os_error * gradcopy(fillstr * d,filestr * dfile,
                         fillstr * s,filestr * sfile,int mode)
{
 os_error      * err;
 fillobjectstr * fillp;
 gradstr         grad;
 int             dprocess;
 int             sprocess;


 fillp=(fillobjectstr*)fob_find(s->fill,sfile);
 sprocess=fillp->data.process;

 err=copyprocessm(&dprocess,dfile,sprocess,sfile,mode);
 if(!err)
 {
  err=fob_copy((fobjptr)&fillp,dfile,s->fill,sfile);
  if(!err)
  {
   d->fill=fillp->key;
   fillp->data.process=dprocess;

   if(sfile!=dfile)
   {
    XMEMCPYX(&grad,(((char*)fillp)+sizeof(fillobjectstr)),sizeof(gradstr));
    mapcolour(sfile,dfile,&grad.fc,mode);
    mapcolour(sfile,dfile,&grad.tc,mode);
    fob_mod(d->fill,dfile,(fobjptr)&fillp);
    XMEMCPYX((((char*)fillp)+sizeof(fillobjectstr)),&grad,sizeof(gradstr));
   }
  }
  else
  {
   deleteprocess(dprocess,dfile);
   d->fill=0;
  }
 }
 else
 {
  d->fill=0;
 }

 return(err);
}






static os_error * gradcreates(filestr * file,filldatastr * data,
                              gradstr * cgradp,fillstr * xnew,int xprocess)
{
 os_error      * err;
 fillobjectstr * fillp;
 gradstr       * gradp;
 int             process;

 err=NULL;

 if(xprocess) process=xprocess;
 else
 {
  err=copyprocess(data->process,&process,file);
 }

 if(!err)
 {
  err=fob_create(sizeof(fillobjectstr)+sizeof(gradstr),file,
                                                     OFILL,(fobjptr)&fillp);
  if(!err)
  {
   xnew->fill=fillp->key;
   fillp->data=*data;
   fillp->data.process=process;
   fillp->filltype=FL_GRAD;
   gradp=(gradstr*)(((char*)fillp)+sizeof(fillobjectstr));
   *gradp=*cgradp;
  }
  else
  {
   deleteprocess(process,file);
  }
 }

 return(err);
}






static os_error * gradwrite(fillstr * fill,buffer * bf,filestr * file)
{
 os_error      * err;
 fillobjectstr * fb;
 gradstr       * grad;


 err=NULL;

 fb=(fillobjectstr*)fob_find(fill->fill,file);
 if(fb)
 {
  grad=(gradstr*)(((char*)fb)+sizeof(fillobjectstr));

           err=bf_printfeol(bf,"{fill {graduated %d ",grad->type);
  if(!err) err=bf_printfeol(bf,"%s",dscvstring(&grad->fc,file));
  if(!err) err=bf_printfeol(bf,"%s",dscvstring(&grad->tc,file));
  if(!err) err=bf_printfeol(bf,"{x %d}",fb->data.x);
  if(!err) err=bf_printfeol(bf,"{y %d}",fb->data.y);

  if(!err) err=bf_printfeol(bf,"{w %d}",grad->rx);
  if(!err) err=bf_printfeol(bf,"{h %d}",grad->ry);

  if(!err) err=bf_printfeol(bf,"{angle 0x%x}",-fb->data.angle);
  if(!err) err=bf_printfeol(bf,"{skew 0x%x}",-fb->data.skew);

  if(!err) err=dswriteprocess(fb->data.process,bf,file);

  if(!err) err=bf_printf(bf,"}\r\n}\r\n");
 }

 return(err);
}




os_error * dsgrad(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 int                 xp;
 int               * dsstack;
 fillstr             fill;
 gradstr             grad;
 filldatastr         filldata;
 int                 seenfc;
 int                 process;


 err=NULL;

 memset(&grad,0,sizeof(gradstr));
 memset(&filldata,0,sizeof(filldatastr));
 filldata.scale=filldata.aspect=0x10000;

 sp=fp+2; /* skip leading type/len */
 xp=sp;

 dsstack=dsstackptr();

 seenfc=0;
 process=0;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case       DSTINT:
                     grad.type=ds->data.integer;
                     break;


   case DSTCOLOURVALUE:
                     if(seenfc)
                     {
                      grad.tc.data.tint.key=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      grad.tc.data.tint.tint=ds1->data.integer;
                      if(nsp>(sp+2+6))
                      {
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       grad.tc.data.tint.overprint=ds1->data.integer;
                      }
                     }
                     else
                     {
                      grad.fc.data.tint.key=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      grad.fc.data.tint.tint=ds1->data.integer;
                      if(nsp>(sp+2+6))
                      {
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       grad.fc.data.tint.overprint=ds1->data.integer;
                      }
                      seenfc=1;
                     }
                     break;


   case         DSTX:
                     filldata.x=ds1->data.integer;
                     break;

   case         DSTY:
                     filldata.y=ds1->data.integer;
                     break;

   case         DSTW:
                     grad.rx=ds1->data.integer;
                     break;

   case         DSTH:
                     grad.ry=ds1->data.integer;
                     break;

   case     DSTANGLE:
                     filldata.angle=-ds1->data.integer;
                     break;

   case      DSTSKEW:
                     filldata.skew=-ds1->data.integer;
                     break;

   case   DSTPROCESS:
                     process=ds->data.integer;
                     break;

  }
  sp=nsp;
 }


 err=gradcreates(loc->file,&filldata,&grad,&fill,process);
 if(!err)
 {
  dsstack=dsstackptr();

  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=3*sizeof(int);
  ds->data.integer=fill.fill;
 }

 return(err);

}









static os_error * gradcreate(filestr * file,filldatastr * data,
                                            fillstr * xnew,fillstr * old)
{
 os_error      * err;

 data->x=cx;
 data->y=cy;
 data->angle=cangle;
 data->skew=cskew;

 err=gradcreates(file,data,&cgrad,xnew,0);

 return(err);

 USE(old);
}





static os_error * gradapply(filestr * file,filltoolstr * tool,
                                                 fillstr * xnew,fillstr * old)
{
 os_error      * err;
 fillobjectstr * fob;
 gradstr       * gradp;
 int             process;


 err=copyprocess(tool->process,&process,file);
 if(!err)
 {
  if(old && old->fill) err=fob_copy((fobjptr)&fob,file,old->fill,file);
  else                 err=fob_create(sizeof(fillobjectstr)+sizeof(gradstr),
                                                  file,OFILL,(fobjptr)&fob);
  if(!err)
  {
   xnew->fill=fob->key;
   fob->filltype=FL_GRAD;
   gradp=(gradstr*)(((char*)fob)+sizeof(fillobjectstr));
   if(!old || !old->fill) XMEMCPYX(gradp,&cgrad,sizeof(gradstr));

   fob->data.x=tool->x;
   fob->data.y=tool->y;
   gradp->rx=FLOOR(ttmul(tool->rx,tool->scale),MINRAD);
   gradp->ry=FLOOR(ttmul(tool->ry,ttmul(tool->scale,tool->aspect)),MINRAD);
   fob->data.angle=tool->angle;
   fob->data.skew=CUT(tool->skew,MINSKEW,MAXSKEW);;
   gradp->fc=tool->c1;
   gradp->tc=tool->c2;
   fob->data.scale=0x10000;
   fob->data.aspect=0x10000;
   fob->data.process=process;
  }
  else
  {
   deleteprocess(process,file);
  }

 }
 return(err);

 USE(old);
}



static os_error * gradtool(filestr * file,filltoolstr * tool,fillstr * old)
{
 fillobjectstr * fob;
 gradstr       * gradp;


 if(old)
 {
  fob=(fillobjectstr*)fob_find(old->fill,file);
  gradp=(gradstr*)(((char*)fob)+sizeof(fillobjectstr));

  tool->process=fob->data.process;
  tool->x=fob->data.x;
  tool->y=fob->data.y;
  tool->rx=gradp->rx;
  tool->ry=gradp->ry;
  tool->angle=fob->data.angle;
  tool->skew=fob->data.skew;
  tool->c1=gradp->fc;
  tool->c2=gradp->tc;
  tool->filltype=fob->filltype;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }
 else
 {
  tool->process=0;
  tool->x=cx;
  tool->y=cy;
  tool->rx=cgrad.rx;
  tool->ry=cgrad.ry;
  tool->angle=cangle;
  tool->skew=cskew;
  tool->c1=cgrad.fc;
  tool->c2=cgrad.tc;
  tool->filltype=FL_GRAD;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }

 return(NULL);
}



/***************************************************************************/

extern dboxstr gradbox;

static viewstr * cview;
static filestr * cfile;

static dboxstr * cparent;


typedef struct grdefstr
{
 char * name;
 int    type;
} grdefstr;


static grdefstr grdefs[]=
{
 "{FILG0}", GRLIN,
 "{FILG1}", GRBLIN,
 "{FILG3}", GRQLIN,
 "{FILG2}", GRRAD,
};


#define NGRAD (sizeof(grdefs)/sizeof(grdefstr))


int graduatedname(int fp)
{
 int          * stack;
 char           temp[256];
 int            n;
 int            s;

 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];

 if(n>=NGRAD) return(0);
 else
 {
  strcpy(temp,grdefs[n].name);
  trans(temp,sizeof(temp));
  assignstring(s,temp);
  return(1);
 }
}



void setgraduated(int fp)
{
 int * stack;
 int   n;

 stack=xstackptr();

 n=stack[fp];

 if(n>=0 && n<NGRAD)
 {
  cgrad.type=grdefs[n].type;
  dbchangevalue(&cgrad.type,cparent);
 }
}


int currentgraduated(int fp)
{
 int * stack;
 int   n;

 stack=xstackptr();

 n=stack[fp];

 if(n>=0 && n<NGRAD)
 {
  return(cgrad.type!=grdefs[n].type);
 }

 return(1);
}






static os_error * wrgrad(int value,char * string)
{
 char temp[256];
 if(value>=NGRAD) value=0;
 strcpy(temp,grdefs[value].name);
 trans(temp,sizeof(temp));
 strcpy(string,temp);
 return(NULL);
}




static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}





static os_error * outr(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inr(int * value,char * string)
{
 os_error * err;

 err=stringtounits(string,value,cview->data.units);
 if(!err)
 {
  *value=FLOOR((*value),MINRAD);
 }

 return(err);
}






static os_error * gradredrawsub(int handle,wimp_redrawstr *redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,6,vfindcolour2(NULL,cfile,&cgrad.fc));
  redrawblock(redrawstr,handle,11,vfindcolour2(NULL,cfile,&cgrad.tc));
  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * gradredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) gradredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}



static void gradfpickclose(colourvalue * colour)
{
 cgrad.fc=*colour;
 wimp_set_icon_state(gradbox.handle,6,(wimp_iconflags)0,(wimp_iconflags)0);
}



static void gradtpickclose(colourvalue * colour)
{
 cgrad.tc=*colour;
 wimp_set_icon_state(gradbox.handle,11,(wimp_iconflags)0,(wimp_iconflags)0);
}




static os_error * gradicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  8: /* from colour */
          err=pickcolour(cfile,&cgrad.fc,gradfpickclose,(dboxstr*)userhandle);
          break;

  case 10: /* to colour */
          err=pickcolour(cfile,&cgrad.tc,gradtpickclose,(dboxstr*)userhandle);
          break;

  case 15:
          err=openmenuparent("graduatedname_menu",handle);
          break;

 }

 return(err);

 USE(handle);
}









static dbiconstr gradicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */

    2, &cx,              DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,
    3, &cy,              DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,
    4, &cgrad.rx,        DBWRITE,  0,   0,    -1, -1,-1,7,     inr, outr,
   17, &cgrad.ry,        DBWRITE,  0,   0,    -1, -1,-1,7,     inr, outr,
   18, &cangle,          DBWRITE,  0,   0,    -1, -1,-1,7,readangle,writeangle,
   21, &cskew,           DBWRITE,  0,   0,    -1, -1,-1,7,readskew,writeskew,

   14, &cgrad.type,      DBTEXT,   0,   0,    -1, -1,-1,7,     NULL,wrgrad,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};






static dboxstr gradbox=
{
 0,
 TFILLGRAD,
 DBPANE,
 0,
 NULL,
 gradicon,
 NULL,
 gradredraw,
 gradicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

};




static os_error * gradpane(int open,fillstr * fill,
                                             viewstr * view,dboxstr * parent)
{
 fillobjectstr * fb;

 if(open)
 {
  cview=view;
  cfile=cview->file;
  cparent=parent;

  if(!fill->fill)
  {
   XMEMCPYX(&cgrad,&defgrad,sizeof(gradstr));
   cx=cy=0;
   cangle=cskew=0;
  }
  else
  {
   fb=(fillobjectstr*)fob_find(fill->fill,cfile);
   if(fb->filltype==FL_GRAD)
   {
    XMEMCPYX(&cgrad,((char*)fb)+sizeof(fillobjectstr),sizeof(gradstr));
    cx=fb->data.x;
    cy=fb->data.y;
    cangle=fb->data.angle;
    cskew=fb->data.skew;
   }
   else
   {
    XMEMCPYX(&cgrad,&defgrad,sizeof(gradstr));
    cx=cy=0;
    cangle=cskew=0;
   }
  }
 }

 return(NULL);
}






static fillblockstr gradblock=
{
 0,0,0,0,


 FL_GRAD,

 NULL,
 gradcopy,
 NULL,
 gradwrite,

 "{FIL03}",
 &gradbox,


 gradpane,
 gradrender,
 gradcreate,

 FLF_BUFFER|FLF_SOLID,
 gradapply,
 gradtool,

 gradrenderd,

};





os_error * fillgradinit(void)
{
 addmessage(fillmode,wimp_MMODECHANGE);
 addmessage(fillmode,wimp_PALETTECHANGE);

 fillmode(NULL,NULL);

/* initradialtable(); */



 return(filllinkblock(&gradblock));
}

